#pragma once

#include "Keyboard.h"
#include "Mouse.h"
#include "Graphics.h"
#include "Player.h"
#include "Brick.h"
#include "moving_fire.h"
#include "Level_exit.h"
#include "Tileset.h"
#include "Decorations.h"
#include "Water.h"

#define LEVELS_TOTAL 10

#define map_width 32
#define map_height 24

class Game
{
public:
	Game( class MainWindow& wnd );
	Game( const Game& ) = delete;
	Game& operator=( const Game& ) = delete;
	void Go();
	bool isStarted = false, gameover = false, current_level_completed = false;
private:
	void ComposeFrame();
	void UpdateModel();

	void level_init(int level);
	void draw_map(int map[map_height][map_width]);
	void reset_map();

	void draw_intro_screen();
	void draw_gameover_screen();
	void draw_level_completed();

	void draw_floor();

	const int boundary = 3; //edges of the room where player can't pass

	int current_level = 1;
	int rand_floor[map_height][map_width];

    Player player;


    Brick bricks[NUM_BRICKS];
	moving_fire fire[NUM_MOVING_FIRES];
	Tile tiles[NUM_TILES];
	Level_exit level_exit;
	Water water[NUM_WATER];

	Surface surface_intro_screen = {"Images\\screen_intro.bmp"};
	Surface surface_level_completed = {"Images\\screen_level_completed.bmp"};
	Surface surface_game_over = {"Images\\screen_game_over.bmp"};

	Surface surface_floor_1 = { "Images\\floor1.bmp" };
	Surface surface_floor_2 = { "Images\\floor2.bmp" };
	Surface surface_floor_3 = { "Images\\floor3.bmp" };
    
private:
	MainWindow& wnd;
	Graphics gfx;
};