#pragma once
#include "Graphics.h"
#include "MainWindow.h"
#include "Brick.h"
#include "moving_fire.h"
#include "Level_exit.h"
#include "Water.h"

#define UP 1
#define LEFT 2
#define DOWN 3
#define RIGHT 4
#define UPLEFT 5
#define UPRIGHT 6
#define DOWNLEFT 7
#define DOWNRIGHT 8

class Player {
public:
	Player() {
		x = 100;
		y = 100;
		player_right_edge = x + width;
		player_bottom_edge = y + height;
		speed = 3;
		default_speed = 3;
		direction = 0;
		friction = 1;
	}
	int getX(), getY(), getSpeed();
	int width = 30;
	int height = 30;
	int default_speed = 3;
	int player_right_edge = 0, player_bottom_edge = 0;							// defining edges for collision computations, they are updated in player movement function in Player.cpp
	int animation_status = 0;
	void setPos(int posx, int posy);
	void setSpeed(int newSpeed);
	void draw(Graphics& gfx);
	void keep_boundaries(int boundary, Graphics& gfx);
	void move(MainWindow& wnd);
	bool collides(int objectX, int objectY, int objectWidth, int objectHeight);
	void check_collision_bricks(int brickX, int brickY);
	bool collides_with_moving_fires(int movingFireX, int movingFireY);
	bool collides_with_level_exit(int levelExitX, int levelExitY);
private:
	int x, y, speed, direction, friction; //friction unused for now
};