#include "Tileset.h"
#include "Graphics.h"

void Tile::draw(Graphics& gfx)
{
	switch (type)
	{
	case 1:
		gfx.DrawSprite(x, y, surface_tile_1, SpriteEffect::Copy{});
		break;
	case 2:
		gfx.DrawSprite(x, y, surface_tile_2, SpriteEffect::Copy{});
		break;
	}
}

void Tile::init(int posX, int posY, int tileType)
{
	x = posX;
	y = posY;
	type = tileType;
	initialized = true;
}

void Tile::deinit()
{
	initialized = false;
}

int Tile::getX()
{
	return x;
}

int Tile::getY()
{
	return y;
}

bool Tile::isInitialized()
{
	return initialized;
}
