#pragma once
#include "Graphics.h"

#define NUM_MOVING_FIRES 4
#define MOVING_FIRE_WIDTH 25
#define MOVING_FIRE_HEIGHT 25
#define MOVING_FIRE_MOVEMENT_RANGE 100

#define UP 1
#define LEFT 2
#define DOWN 3
#define RIGHT 4

class moving_fire
{
public:
	void draw(Graphics& gfx);
	void init(int posX, int posY, int fireType);
	void deinit();
	int getX(), getY();
	void move();
	void wait(int frames);
	bool isInitialized();
private:
	int x, y, x_max, x_min, y_max, y_min, type, direction = 0, speed = 0; // TYPE: 1 = blue & horizontal, 2 = green & vertical, 3 = purple fast & vertical
	int animation_status = 0;
	int movement_break = 0; //used for type 3
	bool initialized = false;
	bool moving = false;
};