#include "Player.h"
#include "Graphics.h"

int Player::getX(){
	return x;
}

int Player::getY(){
	return y;
}

int Player::getSpeed() {
	return speed;
}

void Player::setPos(int newx, int newy) {
	x = newx;
	y = newy;
}

void Player::move(MainWindow& wnd)
{
    if (wnd.kbd.KeyIsPressed(VK_UP)) {
        if (wnd.kbd.KeyIsPressed(VK_LEFT)) { direction = UPLEFT; x -= speed; y -= speed; }
        else if (wnd.kbd.KeyIsPressed(VK_RIGHT)) { direction = UPRIGHT; x += speed; y -= speed; }
        else { direction = UP; y -= speed; }
    }

    if (wnd.kbd.KeyIsPressed(VK_DOWN)) {
        if (wnd.kbd.KeyIsPressed(VK_LEFT)) { direction = DOWNLEFT; x -= speed; y += speed; }
        else if (wnd.kbd.KeyIsPressed(VK_RIGHT)) { direction = DOWNRIGHT; x += speed; y += speed; }
        else { direction = DOWN; y += speed; }
    }

    if (wnd.kbd.KeyIsPressed(VK_LEFT) && !wnd.kbd.KeyIsPressed(VK_DOWN) && !wnd.kbd.KeyIsPressed(VK_UP)) { direction = LEFT; x -= speed; }

    if (wnd.kbd.KeyIsPressed(VK_RIGHT) && !wnd.kbd.KeyIsPressed(VK_DOWN) && !wnd.kbd.KeyIsPressed(VK_UP)) { direction = RIGHT; x += speed; }
}

void Player::draw(Graphics& gfx)
{
    if (animation_status < 10)
    {
        gfx.PutPixel(9 + x, 0 + y, 148, 148, 71);
        gfx.PutPixel(10 + x, 0 + y, 148, 148, 71);
        gfx.PutPixel(11 + x, 0 + y, 186, 186, 125);
        gfx.PutPixel(8 + x, 1 + y, 148, 148, 71);
        gfx.PutPixel(9 + x, 1 + y, 148, 148, 71);
        gfx.PutPixel(10 + x, 1 + y, 163, 163, 88);
        gfx.PutPixel(11 + x, 1 + y, 130, 130, 19);
        gfx.PutPixel(12 + x, 1 + y, 135, 135, 15);
        gfx.PutPixel(8 + x, 2 + y, 148, 148, 71);
        gfx.PutPixel(9 + x, 2 + y, 142, 142, 8);
        gfx.PutPixel(10 + x, 2 + y, 201, 201, 9);
        gfx.PutPixel(11 + x, 2 + y, 161, 161, 46);
        gfx.PutPixel(12 + x, 2 + y, 122, 122, 0);
        gfx.PutPixel(8 + x, 3 + y, 148, 148, 71);
        gfx.PutPixel(9 + x, 3 + y, 155, 155, 11);
        gfx.PutPixel(10 + x, 3 + y, 230, 230, 0);
        gfx.PutPixel(11 + x, 3 + y, 200, 200, 21);
        gfx.PutPixel(12 + x, 3 + y, 137, 137, 0);
        gfx.PutPixel(8 + x, 4 + y, 234, 234, 17);
        gfx.PutPixel(9 + x, 4 + y, 179, 179, 14);
        gfx.PutPixel(10 + x, 4 + y, 227, 227, 48);
        gfx.PutPixel(11 + x, 4 + y, 229, 229, 8);
        gfx.PutPixel(12 + x, 4 + y, 172, 172, 0);
        gfx.PutPixel(7 + x, 5 + y, 188, 188, 122);
        gfx.PutPixel(8 + x, 5 + y, 163, 163, 0);
        gfx.PutPixel(9 + x, 5 + y, 234, 234, 17);
        gfx.PutPixel(10 + x, 5 + y, 235, 235, 92);
        gfx.PutPixel(11 + x, 5 + y, 250, 250, 16);
        gfx.PutPixel(12 + x, 5 + y, 217, 217, 0);
        gfx.PutPixel(13 + x, 5 + y, 181, 181, 27);
        gfx.PutPixel(21 + x, 5 + y, 214, 214, 58);
        gfx.PutPixel(22 + x, 5 + y, 214, 214, 58);
        gfx.PutPixel(23 + x, 5 + y, 214, 214, 58);
        gfx.PutPixel(7 + x, 6 + y, 208, 208, 137);
        gfx.PutPixel(8 + x, 6 + y, 196, 197, 0);
        gfx.PutPixel(9 + x, 6 + y, 253, 253, 0);
        gfx.PutPixel(10 + x, 6 + y, 255, 255, 4);
        gfx.PutPixel(11 + x, 6 + y, 253, 253, 0);
        gfx.PutPixel(12 + x, 6 + y, 230, 230, 0);
        gfx.PutPixel(13 + x, 6 + y, 181, 181, 27);
        gfx.PutPixel(20 + x, 6 + y, 214, 214, 58);
        gfx.PutPixel(21 + x, 6 + y, 203, 203, 104);
        gfx.PutPixel(22 + x, 6 + y, 148, 148, 25);
        gfx.PutPixel(23 + x, 6 + y, 214, 214, 58);
        gfx.PutPixel(7 + x, 7 + y, 196, 197, 0);
        gfx.PutPixel(8 + x, 7 + y, 213, 212, 0);
        gfx.PutPixel(9 + x, 7 + y, 254, 253, 3);
        gfx.PutPixel(10 + x, 7 + y, 255, 255, 0);
        gfx.PutPixel(11 + x, 7 + y, 252, 252, 0);
        gfx.PutPixel(12 + x, 7 + y, 236, 236, 0);
        gfx.PutPixel(13 + x, 7 + y, 204, 204, 39);
        gfx.PutPixel(14 + x, 7 + y, 181, 181, 27);
        gfx.PutPixel(18 + x, 7 + y, 251, 251, 68);
        gfx.PutPixel(19 + x, 7 + y, 228, 228, 126);
        gfx.PutPixel(20 + x, 7 + y, 225, 225, 108);
        gfx.PutPixel(21 + x, 7 + y, 199, 199, 5);
        gfx.PutPixel(22 + x, 7 + y, 163, 163, 0);
        gfx.PutPixel(23 + x, 7 + y, 168, 168, 44);
        gfx.PutPixel(24 + x, 7 + y, 214, 214, 58);
        gfx.PutPixel(6 + x, 8 + y, 166, 166, 18);
        gfx.PutPixel(7 + x, 8 + y, 193, 194, 44);
        gfx.PutPixel(8 + x, 8 + y, 229, 221, 26);
        gfx.PutPixel(9 + x, 8 + y, 252, 237, 54);
        gfx.PutPixel(10 + x, 8 + y, 255, 255, 0);
        gfx.PutPixel(11 + x, 8 + y, 238, 239, 0);
        gfx.PutPixel(12 + x, 8 + y, 246, 247, 0);
        gfx.PutPixel(13 + x, 8 + y, 205, 205, 0);
        gfx.PutPixel(14 + x, 8 + y, 189, 189, 38);
        gfx.PutPixel(15 + x, 8 + y, 221, 221, 135);
        gfx.PutPixel(16 + x, 8 + y, 197, 197, 122);
        gfx.PutPixel(17 + x, 8 + y, 235, 235, 129);
        gfx.PutPixel(18 + x, 8 + y, 253, 253, 64);
        gfx.PutPixel(19 + x, 8 + y, 231, 231, 10);
        gfx.PutPixel(20 + x, 8 + y, 230, 230, 76);
        gfx.PutPixel(21 + x, 8 + y, 224, 224, 10);
        gfx.PutPixel(22 + x, 8 + y, 213, 213, 0);
        gfx.PutPixel(23 + x, 8 + y, 154, 154, 0);
        gfx.PutPixel(24 + x, 8 + y, 214, 214, 58);
        gfx.PutPixel(6 + x, 9 + y, 204, 204, 136);
        gfx.PutPixel(7 + x, 9 + y, 170, 171, 0);
        gfx.PutPixel(8 + x, 9 + y, 239, 232, 24);
        gfx.PutPixel(9 + x, 9 + y, 250, 238, 42);
        gfx.PutPixel(10 + x, 9 + y, 238, 238, 0);
        gfx.PutPixel(11 + x, 9 + y, 234, 226, 31);
        gfx.PutPixel(12 + x, 9 + y, 239, 236, 14);
        gfx.PutPixel(13 + x, 9 + y, 232, 233, 0);
        gfx.PutPixel(14 + x, 9 + y, 219, 220, 0);
        gfx.PutPixel(15 + x, 9 + y, 216, 216, 0);
        gfx.PutPixel(16 + x, 9 + y, 182, 182, 38);
        gfx.PutPixel(17 + x, 9 + y, 229, 230, 10);
        gfx.PutPixel(18 + x, 9 + y, 255, 255, 23);
        gfx.PutPixel(19 + x, 9 + y, 255, 255, 65);
        gfx.PutPixel(20 + x, 9 + y, 254, 254, 65);
        gfx.PutPixel(21 + x, 9 + y, 240, 240, 9);
        gfx.PutPixel(22 + x, 9 + y, 206, 206, 0);
        gfx.PutPixel(23 + x, 9 + y, 232, 232, 128);
        gfx.PutPixel(24 + x, 9 + y, 214, 214, 58);
        gfx.PutPixel(2 + x, 10 + y, 166, 166, 18);
        gfx.PutPixel(3 + x, 10 + y, 218, 217, 12);
        gfx.PutPixel(4 + x, 10 + y, 179, 179, 69);
        gfx.PutPixel(5 + x, 10 + y, 181, 181, 27);
        gfx.PutPixel(6 + x, 10 + y, 181, 181, 27);
        gfx.PutPixel(7 + x, 10 + y, 201, 201, 0);
        gfx.PutPixel(8 + x, 10 + y, 240, 241, 0);
        gfx.PutPixel(9 + x, 10 + y, 242, 244, 0);
        gfx.PutPixel(10 + x, 10 + y, 232, 231, 3);
        gfx.PutPixel(11 + x, 10 + y, 246, 233, 85);
        gfx.PutPixel(12 + x, 10 + y, 237, 231, 34);
        gfx.PutPixel(13 + x, 10 + y, 242, 239, 4);
        gfx.PutPixel(14 + x, 10 + y, 255, 248, 24);
        gfx.PutPixel(15 + x, 10 + y, 255, 248, 29);
        gfx.PutPixel(16 + x, 10 + y, 242, 240, 67);
        gfx.PutPixel(17 + x, 10 + y, 249, 243, 42);
        gfx.PutPixel(18 + x, 10 + y, 255, 250, 63);
        gfx.PutPixel(19 + x, 10 + y, 255, 255, 67);
        gfx.PutPixel(20 + x, 10 + y, 254, 254, 0);
        gfx.PutPixel(21 + x, 10 + y, 222, 222, 0);
        gfx.PutPixel(22 + x, 10 + y, 176, 176, 0);
        gfx.PutPixel(23 + x, 10 + y, 214, 214, 58);
        gfx.PutPixel(2 + x, 11 + y, 207, 207, 144);
        gfx.PutPixel(3 + x, 11 + y, 174, 175, 10);
        gfx.PutPixel(4 + x, 11 + y, 218, 217, 12);
        gfx.PutPixel(5 + x, 11 + y, 232, 228, 32);
        gfx.PutPixel(6 + x, 11 + y, 226, 226, 3);
        gfx.PutPixel(7 + x, 11 + y, 247, 247, 0);
        gfx.PutPixel(8 + x, 11 + y, 244, 244, 0);
        gfx.PutPixel(9 + x, 11 + y, 233, 233, 0);
        gfx.PutPixel(10 + x, 11 + y, 250, 250, 25);
        gfx.PutPixel(11 + x, 11 + y, 252, 250, 97);
        gfx.PutPixel(12 + x, 11 + y, 255, 255, 48);
        gfx.PutPixel(13 + x, 11 + y, 253, 243, 59);
        gfx.PutPixel(14 + x, 11 + y, 248, 227, 118);
        gfx.PutPixel(15 + x, 11 + y, 247, 228, 109);
        gfx.PutPixel(16 + x, 11 + y, 252, 248, 48);
        gfx.PutPixel(17 + x, 11 + y, 250, 233, 76);
        gfx.PutPixel(18 + x, 11 + y, 249, 236, 51);
        gfx.PutPixel(19 + x, 11 + y, 253, 253, 1);
        gfx.PutPixel(20 + x, 11 + y, 246, 246, 0);
        gfx.PutPixel(21 + x, 11 + y, 183, 183, 0);
        gfx.PutPixel(22 + x, 11 + y, 158, 158, 0);
        gfx.PutPixel(23 + x, 11 + y, 214, 214, 58);
        gfx.PutPixel(1 + x, 12 + y, 181, 181, 27);
        gfx.PutPixel(2 + x, 12 + y, 194, 194, 23);
        gfx.PutPixel(3 + x, 12 + y, 214, 214, 30);
        gfx.PutPixel(4 + x, 12 + y, 229, 223, 87);
        gfx.PutPixel(5 + x, 12 + y, 243, 225, 65);
        gfx.PutPixel(6 + x, 12 + y, 247, 244, 14);
        gfx.PutPixel(7 + x, 12 + y, 254, 255, 0);
        gfx.PutPixel(8 + x, 12 + y, 253, 253, 1);
        gfx.PutPixel(9 + x, 12 + y, 245, 245, 25);
        gfx.PutPixel(10 + x, 12 + y, 231, 230, 89);
        gfx.PutPixel(11 + x, 12 + y, 246, 232, 101);
        gfx.PutPixel(12 + x, 12 + y, 253, 247, 97);
        gfx.PutPixel(13 + x, 12 + y, 254, 252, 160);
        gfx.PutPixel(14 + x, 12 + y, 250, 246, 226);
        gfx.PutPixel(15 + x, 12 + y, 242, 238, 205);
        gfx.PutPixel(16 + x, 12 + y, 251, 249, 157);
        gfx.PutPixel(17 + x, 12 + y, 250, 233, 115);
        gfx.PutPixel(18 + x, 12 + y, 237, 224, 46);
        gfx.PutPixel(19 + x, 12 + y, 236, 236, 0);
        gfx.PutPixel(20 + x, 12 + y, 255, 255, 0);
        gfx.PutPixel(21 + x, 12 + y, 230, 230, 0);
        gfx.PutPixel(22 + x, 12 + y, 163, 163, 3);
        gfx.PutPixel(23 + x, 12 + y, 214, 214, 58);
        gfx.PutPixel(0 + x, 13 + y, 218, 217, 12);
        gfx.PutPixel(1 + x, 13 + y, 181, 181, 27);
        gfx.PutPixel(2 + x, 13 + y, 216, 217, 0);
        gfx.PutPixel(3 + x, 13 + y, 247, 240, 41);
        gfx.PutPixel(4 + x, 13 + y, 238, 224, 90);
        gfx.PutPixel(5 + x, 13 + y, 229, 222, 25);
        gfx.PutPixel(6 + x, 13 + y, 232, 231, 5);
        gfx.PutPixel(7 + x, 13 + y, 248, 248, 0);
        gfx.PutPixel(8 + x, 13 + y, 255, 255, 39);
        gfx.PutPixel(9 + x, 13 + y, 253, 254, 82);
        gfx.PutPixel(10 + x, 13 + y, 245, 246, 28);
        gfx.PutPixel(11 + x, 13 + y, 251, 244, 96);
        gfx.PutPixel(12 + x, 13 + y, 250, 235, 100);
        gfx.PutPixel(13 + x, 13 + y, 252, 242, 175);
        gfx.PutPixel(14 + x, 13 + y, 253, 254, 241);
        gfx.PutPixel(15 + x, 13 + y, 247, 246, 173);
        gfx.PutPixel(16 + x, 13 + y, 249, 232, 128);
        gfx.PutPixel(17 + x, 13 + y, 249, 224, 108);
        gfx.PutPixel(18 + x, 13 + y, 233, 220, 47);
        gfx.PutPixel(19 + x, 13 + y, 231, 232, 0);
        gfx.PutPixel(20 + x, 13 + y, 255, 255, 0);
        gfx.PutPixel(21 + x, 13 + y, 246, 247, 0);
        gfx.PutPixel(22 + x, 13 + y, 176, 176, 43);
        gfx.PutPixel(23 + x, 13 + y, 214, 214, 58);
        gfx.PutPixel(0 + x, 14 + y, 135, 135, 58);
        gfx.PutPixel(1 + x, 14 + y, 172, 172, 0);
        gfx.PutPixel(2 + x, 14 + y, 235, 236, 0);
        gfx.PutPixel(3 + x, 14 + y, 254, 244, 40);
        gfx.PutPixel(4 + x, 14 + y, 246, 227, 76);
        gfx.PutPixel(5 + x, 14 + y, 237, 240, 0);
        gfx.PutPixel(6 + x, 14 + y, 239, 240, 0);
        gfx.PutPixel(7 + x, 14 + y, 237, 238, 36);
        gfx.PutPixel(8 + x, 14 + y, 245, 246, 63);
        gfx.PutPixel(9 + x, 14 + y, 254, 251, 56);
        gfx.PutPixel(10 + x, 14 + y, 252, 239, 48);
        gfx.PutPixel(11 + x, 14 + y, 254, 251, 163);
        gfx.PutPixel(12 + x, 14 + y, 251, 241, 139);
        gfx.PutPixel(13 + x, 14 + y, 251, 244, 180);
        gfx.PutPixel(14 + x, 14 + y, 255, 255, 224);
        gfx.PutPixel(15 + x, 14 + y, 253, 253, 128);
        gfx.PutPixel(16 + x, 14 + y, 252, 241, 155);
        gfx.PutPixel(17 + x, 14 + y, 252, 239, 79);
        gfx.PutPixel(18 + x, 14 + y, 242, 230, 38);
        gfx.PutPixel(19 + x, 14 + y, 239, 227, 46);
        gfx.PutPixel(20 + x, 14 + y, 254, 242, 52);
        gfx.PutPixel(21 + x, 14 + y, 252, 250, 61);
        gfx.PutPixel(22 + x, 14 + y, 219, 220, 46);
        gfx.PutPixel(23 + x, 14 + y, 235, 235, 134);
        gfx.PutPixel(24 + x, 14 + y, 251, 251, 68);
        gfx.PutPixel(0 + x, 15 + y, 126, 126, 60);
        gfx.PutPixel(1 + x, 15 + y, 161, 161, 0);
        gfx.PutPixel(2 + x, 15 + y, 229, 230, 0);
        gfx.PutPixel(3 + x, 15 + y, 254, 244, 40);
        gfx.PutPixel(4 + x, 15 + y, 248, 227, 86);
        gfx.PutPixel(5 + x, 15 + y, 254, 246, 32);
        gfx.PutPixel(6 + x, 15 + y, 252, 245, 36);
        gfx.PutPixel(7 + x, 15 + y, 239, 236, 64);
        gfx.PutPixel(8 + x, 15 + y, 241, 242, 56);
        gfx.PutPixel(9 + x, 15 + y, 253, 250, 50);
        gfx.PutPixel(10 + x, 15 + y, 249, 231, 128);
        gfx.PutPixel(11 + x, 15 + y, 253, 250, 197);
        gfx.PutPixel(12 + x, 15 + y, 254, 255, 199);
        gfx.PutPixel(13 + x, 15 + y, 254, 255, 221);
        gfx.PutPixel(14 + x, 15 + y, 255, 255, 232);
        gfx.PutPixel(15 + x, 15 + y, 255, 255, 172);
        gfx.PutPixel(16 + x, 15 + y, 255, 255, 235);
        gfx.PutPixel(17 + x, 15 + y, 255, 255, 120);
        gfx.PutPixel(18 + x, 15 + y, 252, 240, 71);
        gfx.PutPixel(19 + x, 15 + y, 249, 225, 89);
        gfx.PutPixel(20 + x, 15 + y, 250, 235, 71);
        gfx.PutPixel(21 + x, 15 + y, 243, 240, 78);
        gfx.PutPixel(22 + x, 15 + y, 229, 230, 15);
        gfx.PutPixel(23 + x, 15 + y, 214, 214, 58);
        gfx.PutPixel(24 + x, 15 + y, 251, 251, 68);
        gfx.PutPixel(0 + x, 16 + y, 180, 180, 102);
        gfx.PutPixel(1 + x, 16 + y, 161, 161, 17);
        gfx.PutPixel(2 + x, 16 + y, 212, 213, 0);
        gfx.PutPixel(3 + x, 16 + y, 251, 243, 31);
        gfx.PutPixel(4 + x, 16 + y, 248, 229, 81);
        gfx.PutPixel(5 + x, 16 + y, 248, 227, 83);
        gfx.PutPixel(6 + x, 16 + y, 249, 229, 79);
        gfx.PutPixel(7 + x, 16 + y, 253, 245, 38);
        gfx.PutPixel(8 + x, 16 + y, 255, 255, 75);
        gfx.PutPixel(9 + x, 16 + y, 254, 254, 156);
        gfx.PutPixel(10 + x, 16 + y, 252, 252, 170);
        gfx.PutPixel(11 + x, 16 + y, 252, 252, 155);
        gfx.PutPixel(12 + x, 16 + y, 254, 254, 220);
        gfx.PutPixel(13 + x, 16 + y, 255, 255, 255);
        gfx.PutPixel(14 + x, 16 + y, 255, 255, 255);
        gfx.PutPixel(15 + x, 16 + y, 255, 255, 255);
        gfx.PutPixel(16 + x, 16 + y, 255, 255, 254);
        gfx.PutPixel(17 + x, 16 + y, 255, 255, 222);
        gfx.PutPixel(18 + x, 16 + y, 252, 241, 169);
        gfx.PutPixel(19 + x, 16 + y, 250, 237, 89);
        gfx.PutPixel(20 + x, 16 + y, 253, 254, 0);
        gfx.PutPixel(21 + x, 16 + y, 228, 228, 5);
        gfx.PutPixel(22 + x, 16 + y, 196, 196, 34);
        gfx.PutPixel(23 + x, 16 + y, 251, 251, 68);
        gfx.PutPixel(0 + x, 17 + y, 218, 217, 12);
        gfx.PutPixel(1 + x, 17 + y, 194, 194, 100);
        gfx.PutPixel(2 + x, 17 + y, 187, 187, 0);
        gfx.PutPixel(3 + x, 17 + y, 242, 240, 5);
        gfx.PutPixel(4 + x, 17 + y, 254, 250, 14);
        gfx.PutPixel(5 + x, 17 + y, 253, 250, 13);
        gfx.PutPixel(6 + x, 17 + y, 253, 250, 20);
        gfx.PutPixel(7 + x, 17 + y, 253, 252, 76);
        gfx.PutPixel(8 + x, 17 + y, 253, 254, 160);
        gfx.PutPixel(9 + x, 17 + y, 255, 255, 218);
        gfx.PutPixel(10 + x, 17 + y, 253, 254, 231);
        gfx.PutPixel(11 + x, 17 + y, 246, 246, 226);
        gfx.PutPixel(12 + x, 17 + y, 251, 251, 246);
        gfx.PutPixel(13 + x, 17 + y, 255, 255, 255);
        gfx.PutPixel(14 + x, 17 + y, 255, 255, 253);
        gfx.PutPixel(15 + x, 17 + y, 254, 254, 246);
        gfx.PutPixel(16 + x, 17 + y, 255, 255, 253);
        gfx.PutPixel(17 + x, 17 + y, 255, 255, 243);
        gfx.PutPixel(18 + x, 17 + y, 254, 252, 229);
        gfx.PutPixel(19 + x, 17 + y, 253, 250, 153);
        gfx.PutPixel(20 + x, 17 + y, 252, 252, 0);
        gfx.PutPixel(21 + x, 17 + y, 250, 250, 37);
        gfx.PutPixel(22 + x, 17 + y, 245, 245, 113);
        gfx.PutPixel(23 + x, 17 + y, 235, 235, 62);
        gfx.PutPixel(24 + x, 17 + y, 251, 251, 68);
        gfx.PutPixel(0 + x, 18 + y, 161, 161, 104);
        gfx.PutPixel(1 + x, 18 + y, 154, 154, 22);
        gfx.PutPixel(2 + x, 18 + y, 206, 206, 0);
        gfx.PutPixel(3 + x, 18 + y, 251, 252, 0);
        gfx.PutPixel(4 + x, 18 + y, 255, 255, 0);
        gfx.PutPixel(5 + x, 18 + y, 255, 255, 0);
        gfx.PutPixel(6 + x, 18 + y, 255, 255, 0);
        gfx.PutPixel(7 + x, 18 + y, 255, 255, 24);
        gfx.PutPixel(8 + x, 18 + y, 254, 254, 44);
        gfx.PutPixel(9 + x, 18 + y, 255, 255, 75);
        gfx.PutPixel(10 + x, 18 + y, 255, 255, 168);
        gfx.PutPixel(11 + x, 18 + y, 251, 251, 239);
        gfx.PutPixel(12 + x, 18 + y, 254, 254, 255);
        gfx.PutPixel(13 + x, 18 + y, 255, 255, 255);
        gfx.PutPixel(14 + x, 18 + y, 254, 254, 235);
        gfx.PutPixel(15 + x, 18 + y, 251, 252, 180);
        gfx.PutPixel(16 + x, 18 + y, 254, 255, 243);
        gfx.PutPixel(17 + x, 18 + y, 255, 255, 196);
        gfx.PutPixel(18 + x, 18 + y, 255, 255, 109);
        gfx.PutPixel(19 + x, 18 + y, 247, 248, 74);
        gfx.PutPixel(20 + x, 18 + y, 230, 230, 79);
        gfx.PutPixel(21 + x, 18 + y, 249, 249, 22);
        gfx.PutPixel(22 + x, 18 + y, 240, 240, 54);
        gfx.PutPixel(23 + x, 18 + y, 232, 232, 35);
        gfx.PutPixel(24 + x, 18 + y, 251, 251, 68);
        gfx.PutPixel(0 + x, 19 + y, 251, 251, 68);
        gfx.PutPixel(1 + x, 19 + y, 209, 209, 69);
        gfx.PutPixel(2 + x, 19 + y, 230, 230, 0);
        gfx.PutPixel(3 + x, 19 + y, 255, 255, 0);
        gfx.PutPixel(4 + x, 19 + y, 255, 255, 12);
        gfx.PutPixel(5 + x, 19 + y, 255, 255, 71);
        gfx.PutPixel(6 + x, 19 + y, 243, 243, 11);
        gfx.PutPixel(7 + x, 19 + y, 248, 249, 0);
        gfx.PutPixel(8 + x, 19 + y, 255, 255, 22);
        gfx.PutPixel(9 + x, 19 + y, 254, 255, 91);
        gfx.PutPixel(10 + x, 19 + y, 255, 255, 167);
        gfx.PutPixel(11 + x, 19 + y, 255, 255, 214);
        gfx.PutPixel(12 + x, 19 + y, 255, 255, 250);
        gfx.PutPixel(13 + x, 19 + y, 255, 255, 255);
        gfx.PutPixel(14 + x, 19 + y, 255, 255, 228);
        gfx.PutPixel(15 + x, 19 + y, 254, 251, 125);
        gfx.PutPixel(16 + x, 19 + y, 251, 241, 161);
        gfx.PutPixel(17 + x, 19 + y, 254, 249, 147);
        gfx.PutPixel(18 + x, 19 + y, 255, 255, 61);
        gfx.PutPixel(19 + x, 19 + y, 250, 250, 11);
        gfx.PutPixel(20 + x, 19 + y, 241, 241, 54);
        gfx.PutPixel(21 + x, 19 + y, 250, 250, 5);
        gfx.PutPixel(22 + x, 19 + y, 230, 230, 0);
        gfx.PutPixel(23 + x, 19 + y, 236, 236, 109);
        gfx.PutPixel(24 + x, 19 + y, 251, 251, 68);
        gfx.PutPixel(25 + x, 19 + y, 251, 251, 68);
        gfx.PutPixel(26 + x, 19 + y, 251, 251, 68);
        gfx.PutPixel(0 + x, 20 + y, 221, 221, 190);
        gfx.PutPixel(1 + x, 20 + y, 248, 248, 87);
        gfx.PutPixel(2 + x, 20 + y, 246, 246, 25);
        gfx.PutPixel(3 + x, 20 + y, 252, 252, 31);
        gfx.PutPixel(4 + x, 20 + y, 243, 243, 15);
        gfx.PutPixel(5 + x, 20 + y, 240, 241, 86);
        gfx.PutPixel(6 + x, 20 + y, 234, 226, 51);
        gfx.PutPixel(7 + x, 20 + y, 246, 242, 50);
        gfx.PutPixel(8 + x, 20 + y, 252, 249, 93);
        gfx.PutPixel(9 + x, 20 + y, 250, 242, 154);
        gfx.PutPixel(10 + x, 20 + y, 255, 255, 203);
        gfx.PutPixel(11 + x, 20 + y, 253, 254, 183);
        gfx.PutPixel(12 + x, 20 + y, 253, 253, 203);
        gfx.PutPixel(13 + x, 20 + y, 253, 253, 219);
        gfx.PutPixel(14 + x, 20 + y, 252, 253, 207);
        gfx.PutPixel(15 + x, 20 + y, 249, 247, 165);
        gfx.PutPixel(16 + x, 20 + y, 249, 237, 120);
        gfx.PutPixel(17 + x, 20 + y, 253, 248, 89);
        gfx.PutPixel(18 + x, 20 + y, 255, 255, 37);
        gfx.PutPixel(19 + x, 20 + y, 252, 252, 0);
        gfx.PutPixel(20 + x, 20 + y, 245, 245, 0);
        gfx.PutPixel(21 + x, 20 + y, 253, 253, 0);
        gfx.PutPixel(22 + x, 20 + y, 241, 241, 0);
        gfx.PutPixel(23 + x, 20 + y, 196, 196, 0);
        gfx.PutPixel(24 + x, 20 + y, 153, 153, 0);
        gfx.PutPixel(25 + x, 20 + y, 131, 131, 0);
        gfx.PutPixel(26 + x, 20 + y, 159, 159, 14);
        gfx.PutPixel(27 + x, 20 + y, 251, 251, 68);
        gfx.PutPixel(0 + x, 21 + y, 218, 218, 94);
        gfx.PutPixel(1 + x, 21 + y, 208, 208, 10);
        gfx.PutPixel(2 + x, 21 + y, 226, 226, 66);
        gfx.PutPixel(3 + x, 21 + y, 232, 232, 66);
        gfx.PutPixel(4 + x, 21 + y, 222, 222, 0);
        gfx.PutPixel(5 + x, 21 + y, 228, 227, 0);
        gfx.PutPixel(6 + x, 21 + y, 246, 230, 65);
        gfx.PutPixel(7 + x, 21 + y, 253, 246, 121);
        gfx.PutPixel(8 + x, 21 + y, 251, 242, 110);
        gfx.PutPixel(9 + x, 21 + y, 250, 234, 97);
        gfx.PutPixel(10 + x, 21 + y, 255, 255, 165);
        gfx.PutPixel(11 + x, 21 + y, 252, 248, 146);
        gfx.PutPixel(12 + x, 21 + y, 251, 249, 147);
        gfx.PutPixel(13 + x, 21 + y, 252, 252, 146);
        gfx.PutPixel(14 + x, 21 + y, 249, 248, 167);
        gfx.PutPixel(15 + x, 21 + y, 240, 236, 220);
        gfx.PutPixel(16 + x, 21 + y, 250, 250, 134);
        gfx.PutPixel(17 + x, 21 + y, 254, 255, 31);
        gfx.PutPixel(18 + x, 21 + y, 253, 253, 0);
        gfx.PutPixel(19 + x, 21 + y, 243, 243, 0);
        gfx.PutPixel(20 + x, 21 + y, 228, 228, 0);
        gfx.PutPixel(21 + x, 21 + y, 252, 252, 0);
        gfx.PutPixel(22 + x, 21 + y, 255, 255, 0);
        gfx.PutPixel(23 + x, 21 + y, 223, 223, 0);
        gfx.PutPixel(24 + x, 21 + y, 195, 195, 0);
        gfx.PutPixel(25 + x, 21 + y, 201, 201, 2);
        gfx.PutPixel(26 + x, 21 + y, 186, 186, 7);
        gfx.PutPixel(27 + x, 21 + y, 149, 149, 5);
        gfx.PutPixel(28 + x, 21 + y, 251, 251, 68);
        gfx.PutPixel(1 + x, 22 + y, 218, 217, 12);
        gfx.PutPixel(2 + x, 22 + y, 161, 161, 21);
        gfx.PutPixel(3 + x, 22 + y, 193, 193, 30);
        gfx.PutPixel(4 + x, 22 + y, 240, 240, 69);
        gfx.PutPixel(5 + x, 22 + y, 251, 251, 68);
        gfx.PutPixel(6 + x, 22 + y, 245, 243, 19);
        gfx.PutPixel(7 + x, 22 + y, 251, 250, 16);
        gfx.PutPixel(8 + x, 22 + y, 252, 250, 16);
        gfx.PutPixel(9 + x, 22 + y, 249, 246, 14);
        gfx.PutPixel(10 + x, 22 + y, 255, 255, 28);
        gfx.PutPixel(11 + x, 22 + y, 250, 236, 84);
        gfx.PutPixel(12 + x, 22 + y, 251, 244, 135);
        gfx.PutPixel(13 + x, 22 + y, 251, 252, 160);
        gfx.PutPixel(14 + x, 22 + y, 249, 244, 152);
        gfx.PutPixel(15 + x, 22 + y, 247, 229, 109);
        gfx.PutPixel(16 + x, 22 + y, 253, 250, 34);
        gfx.PutPixel(17 + x, 22 + y, 255, 254, 9);
        gfx.PutPixel(18 + x, 22 + y, 240, 239, 10);
        gfx.PutPixel(19 + x, 22 + y, 234, 234, 8);
        gfx.PutPixel(20 + x, 22 + y, 252, 252, 0);
        gfx.PutPixel(21 + x, 22 + y, 254, 254, 0);
        gfx.PutPixel(22 + x, 22 + y, 251, 251, 0);
        gfx.PutPixel(23 + x, 22 + y, 218, 218, 0);
        gfx.PutPixel(24 + x, 22 + y, 198, 198, 0);
        gfx.PutPixel(25 + x, 22 + y, 207, 207, 12);
        gfx.PutPixel(26 + x, 22 + y, 185, 185, 57);
        gfx.PutPixel(27 + x, 22 + y, 157, 157, 15);
        gfx.PutPixel(28 + x, 22 + y, 169, 169, 70);
        gfx.PutPixel(2 + x, 23 + y, 162, 162, 93);
        gfx.PutPixel(3 + x, 23 + y, 196, 196, 136);
        gfx.PutPixel(4 + x, 23 + y, 251, 251, 68);
        gfx.PutPixel(5 + x, 23 + y, 251, 251, 68);
        gfx.PutPixel(6 + x, 23 + y, 230, 231, 89);
        gfx.PutPixel(7 + x, 23 + y, 222, 223, 0);
        gfx.PutPixel(8 + x, 23 + y, 232, 232, 0);
        gfx.PutPixel(9 + x, 23 + y, 212, 213, 0);
        gfx.PutPixel(10 + x, 23 + y, 255, 255, 0);
        gfx.PutPixel(11 + x, 23 + y, 255, 251, 16);
        gfx.PutPixel(12 + x, 23 + y, 253, 251, 115);
        gfx.PutPixel(13 + x, 23 + y, 247, 248, 203);
        gfx.PutPixel(14 + x, 23 + y, 244, 245, 207);
        gfx.PutPixel(15 + x, 23 + y, 255, 251, 102);
        gfx.PutPixel(16 + x, 23 + y, 255, 253, 16);
        gfx.PutPixel(17 + x, 23 + y, 253, 239, 53);
        gfx.PutPixel(18 + x, 23 + y, 234, 223, 96);
        gfx.PutPixel(19 + x, 23 + y, 230, 231, 69);
        gfx.PutPixel(20 + x, 23 + y, 255, 255, 0);
        gfx.PutPixel(21 + x, 23 + y, 252, 252, 0);
        gfx.PutPixel(22 + x, 23 + y, 221, 221, 0);
        gfx.PutPixel(23 + x, 23 + y, 200, 200, 0);
        gfx.PutPixel(24 + x, 23 + y, 181, 181, 0);
        gfx.PutPixel(25 + x, 23 + y, 141, 141, 0);
        gfx.PutPixel(26 + x, 23 + y, 126, 126, 0);
        gfx.PutPixel(27 + x, 23 + y, 128, 128, 0);
        gfx.PutPixel(28 + x, 23 + y, 166, 166, 18);
        gfx.PutPixel(6 + x, 24 + y, 251, 251, 68);
        gfx.PutPixel(7 + x, 24 + y, 243, 243, 160);
        gfx.PutPixel(8 + x, 24 + y, 242, 242, 145);
        gfx.PutPixel(9 + x, 24 + y, 233, 233, 90);
        gfx.PutPixel(10 + x, 24 + y, 244, 244, 124);
        gfx.PutPixel(11 + x, 24 + y, 246, 246, 57);
        gfx.PutPixel(12 + x, 24 + y, 249, 250, 35);
        gfx.PutPixel(13 + x, 24 + y, 249, 243, 117);
        gfx.PutPixel(14 + x, 24 + y, 245, 231, 156);
        gfx.PutPixel(15 + x, 24 + y, 252, 239, 107);
        gfx.PutPixel(16 + x, 24 + y, 249, 236, 60);
        gfx.PutPixel(17 + x, 24 + y, 239, 226, 45);
        gfx.PutPixel(18 + x, 24 + y, 236, 231, 50);
        gfx.PutPixel(19 + x, 24 + y, 247, 246, 37);
        gfx.PutPixel(20 + x, 24 + y, 255, 255, 0);
        gfx.PutPixel(21 + x, 24 + y, 238, 238, 0);
        gfx.PutPixel(22 + x, 24 + y, 191, 191, 0);
        gfx.PutPixel(23 + x, 24 + y, 165, 165, 0);
        gfx.PutPixel(24 + x, 24 + y, 131, 131, 0);
        gfx.PutPixel(25 + x, 24 + y, 120, 120, 29);
        gfx.PutPixel(26 + x, 24 + y, 166, 166, 18);
        gfx.PutPixel(27 + x, 24 + y, 166, 166, 18);
        gfx.PutPixel(6 + x, 25 + y, 251, 251, 68);
        gfx.PutPixel(7 + x, 25 + y, 239, 239, 110);
        gfx.PutPixel(8 + x, 25 + y, 239, 239, 107);
        gfx.PutPixel(9 + x, 25 + y, 237, 237, 84);
        gfx.PutPixel(10 + x, 25 + y, 233, 233, 61);
        gfx.PutPixel(11 + x, 25 + y, 232, 232, 36);
        gfx.PutPixel(12 + x, 25 + y, 245, 246, 0);
        gfx.PutPixel(13 + x, 25 + y, 255, 248, 14);
        gfx.PutPixel(14 + x, 25 + y, 248, 233, 46);
        gfx.PutPixel(15 + x, 25 + y, 236, 221, 61);
        gfx.PutPixel(16 + x, 25 + y, 246, 232, 99);
        gfx.PutPixel(17 + x, 25 + y, 230, 226, 32);
        gfx.PutPixel(18 + x, 25 + y, 241, 242, 0);
        gfx.PutPixel(19 + x, 25 + y, 242, 242, 0);
        gfx.PutPixel(20 + x, 25 + y, 195, 195, 0);
        gfx.PutPixel(21 + x, 25 + y, 188, 188, 0);
        gfx.PutPixel(22 + x, 25 + y, 167, 167, 0);
        gfx.PutPixel(23 + x, 25 + y, 122, 122, 0);
        gfx.PutPixel(24 + x, 25 + y, 146, 146, 76);
        gfx.PutPixel(25 + x, 25 + y, 166, 166, 18);
        gfx.PutPixel(26 + x, 25 + y, 166, 166, 18);
        gfx.PutPixel(10 + x, 26 + y, 251, 251, 68);
        gfx.PutPixel(11 + x, 26 + y, 234, 234, 57);
        gfx.PutPixel(12 + x, 26 + y, 240, 240, 0);
        gfx.PutPixel(13 + x, 26 + y, 255, 255, 8);
        gfx.PutPixel(14 + x, 26 + y, 247, 248, 9);
        gfx.PutPixel(15 + x, 26 + y, 222, 224, 1);
        gfx.PutPixel(16 + x, 26 + y, 248, 250, 80);
        gfx.PutPixel(17 + x, 26 + y, 233, 233, 27);
        gfx.PutPixel(18 + x, 26 + y, 229, 229, 0);
        gfx.PutPixel(19 + x, 26 + y, 199, 199, 0);
        gfx.PutPixel(20 + x, 26 + y, 120, 120, 2);
        gfx.PutPixel(21 + x, 26 + y, 186, 186, 78);
        gfx.PutPixel(22 + x, 26 + y, 166, 166, 18);
        gfx.PutPixel(23 + x, 26 + y, 139, 139, 54);
        gfx.PutPixel(24 + x, 26 + y, 166, 166, 18);
        gfx.PutPixel(11 + x, 27 + y, 230, 230, 121);
        gfx.PutPixel(12 + x, 27 + y, 222, 222, 0);
        gfx.PutPixel(13 + x, 27 + y, 255, 255, 53);
        gfx.PutPixel(14 + x, 27 + y, 244, 244, 84);
        gfx.PutPixel(15 + x, 27 + y, 223, 223, 0);
        gfx.PutPixel(16 + x, 27 + y, 245, 245, 13);
        gfx.PutPixel(17 + x, 27 + y, 243, 243, 57);
        gfx.PutPixel(18 + x, 27 + y, 227, 227, 82);
        gfx.PutPixel(19 + x, 27 + y, 205, 205, 74);
        gfx.PutPixel(20 + x, 27 + y, 211, 211, 120);
        gfx.PutPixel(22 + x, 27 + y, 166, 166, 18);
        gfx.PutPixel(23 + x, 27 + y, 181, 181, 27);
        gfx.PutPixel(10 + x, 28 + y, 251, 251, 68);
        gfx.PutPixel(11 + x, 28 + y, 222, 222, 106);
        gfx.PutPixel(12 + x, 28 + y, 218, 218, 0);
        gfx.PutPixel(13 + x, 28 + y, 248, 248, 59);
        gfx.PutPixel(14 + x, 28 + y, 229, 229, 93);
        gfx.PutPixel(15 + x, 28 + y, 222, 222, 0);
        gfx.PutPixel(16 + x, 28 + y, 233, 233, 23);
        gfx.PutPixel(17 + x, 28 + y, 251, 251, 68);
        gfx.PutPixel(18 + x, 28 + y, 251, 251, 68);
        gfx.PutPixel(11 + x, 29 + y, 251, 251, 68);
        gfx.PutPixel(12 + x, 29 + y, 243, 243, 103);
        gfx.PutPixel(13 + x, 29 + y, 229, 229, 7);
        gfx.PutPixel(14 + x, 29 + y, 217, 217, 26);
        gfx.PutPixel(15 + x, 29 + y, 207, 207, 20);
        gfx.PutPixel(16 + x, 29 + y, 251, 251, 68);

    }

    if (animation_status >= 10 && animation_status < 20)
    {
        gfx.PutPixel(8 + x, 0 + y, 218, 218, 94);
        gfx.PutPixel(9 + x, 0 + y, 221, 221, 190);
        gfx.PutPixel(10 + x, 0 + y, 251, 251, 68);
        gfx.PutPixel(11 + x, 0 + y, 161, 161, 104);
        gfx.PutPixel(12 + x, 0 + y, 218, 217, 12);
        gfx.PutPixel(13 + x, 0 + y, 180, 180, 102);
        gfx.PutPixel(14 + x, 0 + y, 126, 126, 60);
        gfx.PutPixel(15 + x, 0 + y, 135, 135, 58);
        gfx.PutPixel(16 + x, 0 + y, 218, 217, 12);
        gfx.PutPixel(7 + x, 1 + y, 218, 217, 12);
        gfx.PutPixel(8 + x, 1 + y, 208, 208, 10);
        gfx.PutPixel(9 + x, 1 + y, 248, 248, 87);
        gfx.PutPixel(10 + x, 1 + y, 209, 209, 69);
        gfx.PutPixel(11 + x, 1 + y, 154, 154, 22);
        gfx.PutPixel(12 + x, 1 + y, 194, 194, 100);
        gfx.PutPixel(13 + x, 1 + y, 161, 161, 17);
        gfx.PutPixel(14 + x, 1 + y, 161, 161, 0);
        gfx.PutPixel(15 + x, 1 + y, 172, 172, 0);
        gfx.PutPixel(16 + x, 1 + y, 181, 181, 27);
        gfx.PutPixel(17 + x, 1 + y, 181, 181, 27);
        gfx.PutPixel(6 + x, 2 + y, 162, 162, 93);
        gfx.PutPixel(7 + x, 2 + y, 161, 161, 21);
        gfx.PutPixel(8 + x, 2 + y, 226, 226, 66);
        gfx.PutPixel(9 + x, 2 + y, 246, 246, 25);
        gfx.PutPixel(10 + x, 2 + y, 230, 230, 0);
        gfx.PutPixel(11 + x, 2 + y, 206, 206, 0);
        gfx.PutPixel(12 + x, 2 + y, 187, 187, 0);
        gfx.PutPixel(13 + x, 2 + y, 212, 213, 0);
        gfx.PutPixel(14 + x, 2 + y, 229, 230, 0);
        gfx.PutPixel(15 + x, 2 + y, 235, 236, 0);
        gfx.PutPixel(16 + x, 2 + y, 216, 217, 0);
        gfx.PutPixel(17 + x, 2 + y, 194, 194, 23);
        gfx.PutPixel(18 + x, 2 + y, 207, 207, 144);
        gfx.PutPixel(19 + x, 2 + y, 166, 166, 18);
        gfx.PutPixel(6 + x, 3 + y, 196, 196, 136);
        gfx.PutPixel(7 + x, 3 + y, 193, 193, 30);
        gfx.PutPixel(8 + x, 3 + y, 232, 232, 66);
        gfx.PutPixel(9 + x, 3 + y, 252, 252, 31);
        gfx.PutPixel(10 + x, 3 + y, 255, 255, 0);
        gfx.PutPixel(11 + x, 3 + y, 251, 252, 0);
        gfx.PutPixel(12 + x, 3 + y, 242, 240, 5);
        gfx.PutPixel(13 + x, 3 + y, 251, 243, 31);
        gfx.PutPixel(14 + x, 3 + y, 254, 244, 40);
        gfx.PutPixel(15 + x, 3 + y, 254, 244, 40);
        gfx.PutPixel(16 + x, 3 + y, 247, 240, 41);
        gfx.PutPixel(17 + x, 3 + y, 214, 214, 30);
        gfx.PutPixel(18 + x, 3 + y, 174, 175, 10);
        gfx.PutPixel(19 + x, 3 + y, 218, 217, 12);
        gfx.PutPixel(6 + x, 4 + y, 251, 251, 68);
        gfx.PutPixel(7 + x, 4 + y, 240, 240, 69);
        gfx.PutPixel(8 + x, 4 + y, 222, 222, 0);
        gfx.PutPixel(9 + x, 4 + y, 243, 243, 15);
        gfx.PutPixel(10 + x, 4 + y, 255, 255, 12);
        gfx.PutPixel(11 + x, 4 + y, 255, 255, 0);
        gfx.PutPixel(12 + x, 4 + y, 254, 250, 14);
        gfx.PutPixel(13 + x, 4 + y, 248, 229, 81);
        gfx.PutPixel(14 + x, 4 + y, 248, 227, 86);
        gfx.PutPixel(15 + x, 4 + y, 246, 227, 76);
        gfx.PutPixel(16 + x, 4 + y, 238, 224, 90);
        gfx.PutPixel(17 + x, 4 + y, 229, 223, 87);
        gfx.PutPixel(18 + x, 4 + y, 218, 217, 12);
        gfx.PutPixel(19 + x, 4 + y, 179, 179, 69);
        gfx.PutPixel(6 + x, 5 + y, 251, 251, 68);
        gfx.PutPixel(7 + x, 5 + y, 251, 251, 68);
        gfx.PutPixel(8 + x, 5 + y, 228, 227, 0);
        gfx.PutPixel(9 + x, 5 + y, 240, 241, 86);
        gfx.PutPixel(10 + x, 5 + y, 255, 255, 71);
        gfx.PutPixel(11 + x, 5 + y, 255, 255, 0);
        gfx.PutPixel(12 + x, 5 + y, 253, 250, 13);
        gfx.PutPixel(13 + x, 5 + y, 248, 227, 83);
        gfx.PutPixel(14 + x, 5 + y, 254, 246, 32);
        gfx.PutPixel(15 + x, 5 + y, 237, 240, 0);
        gfx.PutPixel(16 + x, 5 + y, 229, 222, 25);
        gfx.PutPixel(17 + x, 5 + y, 243, 225, 65);
        gfx.PutPixel(18 + x, 5 + y, 232, 228, 32);
        gfx.PutPixel(19 + x, 5 + y, 181, 181, 27);
        gfx.PutPixel(4 + x, 6 + y, 251, 251, 68);
        gfx.PutPixel(5 + x, 6 + y, 251, 251, 68);
        gfx.PutPixel(6 + x, 6 + y, 230, 231, 89);
        gfx.PutPixel(7 + x, 6 + y, 245, 243, 19);
        gfx.PutPixel(8 + x, 6 + y, 246, 230, 65);
        gfx.PutPixel(9 + x, 6 + y, 234, 226, 51);
        gfx.PutPixel(10 + x, 6 + y, 243, 243, 11);
        gfx.PutPixel(11 + x, 6 + y, 255, 255, 0);
        gfx.PutPixel(12 + x, 6 + y, 253, 250, 20);
        gfx.PutPixel(13 + x, 6 + y, 249, 229, 79);
        gfx.PutPixel(14 + x, 6 + y, 252, 245, 36);
        gfx.PutPixel(15 + x, 6 + y, 239, 240, 0);
        gfx.PutPixel(16 + x, 6 + y, 232, 231, 5);
        gfx.PutPixel(17 + x, 6 + y, 247, 244, 14);
        gfx.PutPixel(18 + x, 6 + y, 226, 226, 3);
        gfx.PutPixel(19 + x, 6 + y, 181, 181, 27);
        gfx.PutPixel(20 + x, 6 + y, 204, 204, 136);
        gfx.PutPixel(21 + x, 6 + y, 166, 166, 18);
        gfx.PutPixel(4 + x, 7 + y, 239, 239, 110);
        gfx.PutPixel(5 + x, 7 + y, 243, 243, 160);
        gfx.PutPixel(6 + x, 7 + y, 222, 223, 0);
        gfx.PutPixel(7 + x, 7 + y, 251, 250, 16);
        gfx.PutPixel(8 + x, 7 + y, 253, 246, 121);
        gfx.PutPixel(9 + x, 7 + y, 246, 242, 50);
        gfx.PutPixel(10 + x, 7 + y, 248, 249, 0);
        gfx.PutPixel(11 + x, 7 + y, 255, 255, 24);
        gfx.PutPixel(12 + x, 7 + y, 253, 252, 76);
        gfx.PutPixel(13 + x, 7 + y, 253, 245, 38);
        gfx.PutPixel(14 + x, 7 + y, 239, 236, 64);
        gfx.PutPixel(15 + x, 7 + y, 237, 238, 36);
        gfx.PutPixel(16 + x, 7 + y, 248, 248, 0);
        gfx.PutPixel(17 + x, 7 + y, 254, 255, 0);
        gfx.PutPixel(18 + x, 7 + y, 247, 247, 0);
        gfx.PutPixel(19 + x, 7 + y, 201, 201, 0);
        gfx.PutPixel(20 + x, 7 + y, 170, 171, 0);
        gfx.PutPixel(21 + x, 7 + y, 193, 194, 44);
        gfx.PutPixel(22 + x, 7 + y, 196, 197, 0);
        gfx.PutPixel(23 + x, 7 + y, 208, 208, 137);
        gfx.PutPixel(24 + x, 7 + y, 188, 188, 122);
        gfx.PutPixel(4 + x, 8 + y, 239, 239, 107);
        gfx.PutPixel(5 + x, 8 + y, 242, 242, 145);
        gfx.PutPixel(6 + x, 8 + y, 232, 232, 0);
        gfx.PutPixel(7 + x, 8 + y, 252, 250, 16);
        gfx.PutPixel(8 + x, 8 + y, 251, 242, 110);
        gfx.PutPixel(9 + x, 8 + y, 252, 249, 93);
        gfx.PutPixel(10 + x, 8 + y, 255, 255, 22);
        gfx.PutPixel(11 + x, 8 + y, 254, 254, 44);
        gfx.PutPixel(12 + x, 8 + y, 253, 254, 160);
        gfx.PutPixel(13 + x, 8 + y, 255, 255, 75);
        gfx.PutPixel(14 + x, 8 + y, 241, 242, 56);
        gfx.PutPixel(15 + x, 8 + y, 245, 246, 63);
        gfx.PutPixel(16 + x, 8 + y, 255, 255, 39);
        gfx.PutPixel(17 + x, 8 + y, 253, 253, 1);
        gfx.PutPixel(18 + x, 8 + y, 244, 244, 0);
        gfx.PutPixel(19 + x, 8 + y, 240, 241, 0);
        gfx.PutPixel(20 + x, 8 + y, 239, 232, 24);
        gfx.PutPixel(21 + x, 8 + y, 229, 221, 26);
        gfx.PutPixel(22 + x, 8 + y, 213, 212, 0);
        gfx.PutPixel(23 + x, 8 + y, 196, 197, 0);
        gfx.PutPixel(24 + x, 8 + y, 163, 163, 0);
        gfx.PutPixel(25 + x, 8 + y, 234, 234, 17);
        gfx.PutPixel(26 + x, 8 + y, 148, 148, 71);
        gfx.PutPixel(27 + x, 8 + y, 148, 148, 71);
        gfx.PutPixel(28 + x, 8 + y, 148, 148, 71);
        gfx.PutPixel(4 + x, 9 + y, 237, 237, 84);
        gfx.PutPixel(5 + x, 9 + y, 233, 233, 90);
        gfx.PutPixel(6 + x, 9 + y, 212, 213, 0);
        gfx.PutPixel(7 + x, 9 + y, 249, 246, 14);
        gfx.PutPixel(8 + x, 9 + y, 250, 234, 97);
        gfx.PutPixel(9 + x, 9 + y, 250, 242, 154);
        gfx.PutPixel(10 + x, 9 + y, 254, 255, 91);
        gfx.PutPixel(11 + x, 9 + y, 255, 255, 75);
        gfx.PutPixel(12 + x, 9 + y, 255, 255, 218);
        gfx.PutPixel(13 + x, 9 + y, 254, 254, 156);
        gfx.PutPixel(14 + x, 9 + y, 253, 250, 50);
        gfx.PutPixel(15 + x, 9 + y, 254, 251, 56);
        gfx.PutPixel(16 + x, 9 + y, 253, 254, 82);
        gfx.PutPixel(17 + x, 9 + y, 245, 245, 25);
        gfx.PutPixel(18 + x, 9 + y, 233, 233, 0);
        gfx.PutPixel(19 + x, 9 + y, 242, 244, 0);
        gfx.PutPixel(20 + x, 9 + y, 250, 238, 42);
        gfx.PutPixel(21 + x, 9 + y, 252, 237, 54);
        gfx.PutPixel(22 + x, 9 + y, 254, 253, 3);
        gfx.PutPixel(23 + x, 9 + y, 253, 253, 0);
        gfx.PutPixel(24 + x, 9 + y, 234, 234, 17);
        gfx.PutPixel(25 + x, 9 + y, 179, 179, 14);
        gfx.PutPixel(26 + x, 9 + y, 155, 155, 11);
        gfx.PutPixel(27 + x, 9 + y, 142, 142, 8);
        gfx.PutPixel(28 + x, 9 + y, 148, 148, 71);
        gfx.PutPixel(29 + x, 9 + y, 148, 148, 71);
        gfx.PutPixel(1 + x, 10 + y, 251, 251, 68);
        gfx.PutPixel(3 + x, 10 + y, 251, 251, 68);
        gfx.PutPixel(4 + x, 10 + y, 233, 233, 61);
        gfx.PutPixel(5 + x, 10 + y, 244, 244, 124);
        gfx.PutPixel(6 + x, 10 + y, 255, 255, 0);
        gfx.PutPixel(7 + x, 10 + y, 255, 255, 28);
        gfx.PutPixel(8 + x, 10 + y, 255, 255, 165);
        gfx.PutPixel(9 + x, 10 + y, 255, 255, 203);
        gfx.PutPixel(10 + x, 10 + y, 255, 255, 167);
        gfx.PutPixel(11 + x, 10 + y, 255, 255, 168);
        gfx.PutPixel(12 + x, 10 + y, 253, 254, 231);
        gfx.PutPixel(13 + x, 10 + y, 252, 252, 170);
        gfx.PutPixel(14 + x, 10 + y, 249, 231, 128);
        gfx.PutPixel(15 + x, 10 + y, 252, 239, 48);
        gfx.PutPixel(16 + x, 10 + y, 245, 246, 28);
        gfx.PutPixel(17 + x, 10 + y, 231, 230, 89);
        gfx.PutPixel(18 + x, 10 + y, 250, 250, 25);
        gfx.PutPixel(19 + x, 10 + y, 232, 231, 3);
        gfx.PutPixel(20 + x, 10 + y, 238, 238, 0);
        gfx.PutPixel(21 + x, 10 + y, 255, 255, 0);
        gfx.PutPixel(22 + x, 10 + y, 255, 255, 0);
        gfx.PutPixel(23 + x, 10 + y, 255, 255, 4);
        gfx.PutPixel(24 + x, 10 + y, 235, 235, 92);
        gfx.PutPixel(25 + x, 10 + y, 227, 227, 48);
        gfx.PutPixel(26 + x, 10 + y, 230, 230, 0);
        gfx.PutPixel(27 + x, 10 + y, 201, 201, 9);
        gfx.PutPixel(28 + x, 10 + y, 163, 163, 88);
        gfx.PutPixel(29 + x, 10 + y, 148, 148, 71);
        gfx.PutPixel(0 + x, 11 + y, 251, 251, 68);
        gfx.PutPixel(1 + x, 11 + y, 222, 222, 106);
        gfx.PutPixel(2 + x, 11 + y, 230, 230, 121);
        gfx.PutPixel(3 + x, 11 + y, 234, 234, 57);
        gfx.PutPixel(4 + x, 11 + y, 232, 232, 36);
        gfx.PutPixel(5 + x, 11 + y, 246, 246, 57);
        gfx.PutPixel(6 + x, 11 + y, 255, 251, 16);
        gfx.PutPixel(7 + x, 11 + y, 250, 236, 84);
        gfx.PutPixel(8 + x, 11 + y, 252, 248, 146);
        gfx.PutPixel(9 + x, 11 + y, 253, 254, 183);
        gfx.PutPixel(10 + x, 11 + y, 255, 255, 214);
        gfx.PutPixel(11 + x, 11 + y, 251, 251, 239);
        gfx.PutPixel(12 + x, 11 + y, 246, 246, 226);
        gfx.PutPixel(13 + x, 11 + y, 252, 252, 155);
        gfx.PutPixel(14 + x, 11 + y, 253, 250, 197);
        gfx.PutPixel(15 + x, 11 + y, 254, 251, 163);
        gfx.PutPixel(16 + x, 11 + y, 251, 244, 96);
        gfx.PutPixel(17 + x, 11 + y, 246, 232, 101);
        gfx.PutPixel(18 + x, 11 + y, 252, 250, 97);
        gfx.PutPixel(19 + x, 11 + y, 246, 233, 85);
        gfx.PutPixel(20 + x, 11 + y, 234, 226, 31);
        gfx.PutPixel(21 + x, 11 + y, 238, 239, 0);
        gfx.PutPixel(22 + x, 11 + y, 252, 252, 0);
        gfx.PutPixel(23 + x, 11 + y, 253, 253, 0);
        gfx.PutPixel(24 + x, 11 + y, 250, 250, 16);
        gfx.PutPixel(25 + x, 11 + y, 229, 229, 8);
        gfx.PutPixel(26 + x, 11 + y, 200, 200, 21);
        gfx.PutPixel(27 + x, 11 + y, 161, 161, 46);
        gfx.PutPixel(28 + x, 11 + y, 130, 130, 19);
        gfx.PutPixel(29 + x, 11 + y, 186, 186, 125);
        gfx.PutPixel(0 + x, 12 + y, 243, 243, 103);
        gfx.PutPixel(1 + x, 12 + y, 218, 218, 0);
        gfx.PutPixel(2 + x, 12 + y, 222, 222, 0);
        gfx.PutPixel(3 + x, 12 + y, 240, 240, 0);
        gfx.PutPixel(4 + x, 12 + y, 245, 246, 0);
        gfx.PutPixel(5 + x, 12 + y, 249, 250, 35);
        gfx.PutPixel(6 + x, 12 + y, 253, 251, 115);
        gfx.PutPixel(7 + x, 12 + y, 251, 244, 135);
        gfx.PutPixel(8 + x, 12 + y, 251, 249, 147);
        gfx.PutPixel(9 + x, 12 + y, 253, 253, 203);
        gfx.PutPixel(10 + x, 12 + y, 255, 255, 250);
        gfx.PutPixel(11 + x, 12 + y, 254, 254, 255);
        gfx.PutPixel(12 + x, 12 + y, 251, 251, 246);
        gfx.PutPixel(13 + x, 12 + y, 254, 254, 220);
        gfx.PutPixel(14 + x, 12 + y, 254, 255, 199);
        gfx.PutPixel(15 + x, 12 + y, 251, 241, 139);
        gfx.PutPixel(16 + x, 12 + y, 250, 235, 100);
        gfx.PutPixel(17 + x, 12 + y, 253, 247, 97);
        gfx.PutPixel(18 + x, 12 + y, 255, 255, 48);
        gfx.PutPixel(19 + x, 12 + y, 237, 231, 34);
        gfx.PutPixel(20 + x, 12 + y, 239, 236, 14);
        gfx.PutPixel(21 + x, 12 + y, 246, 247, 0);
        gfx.PutPixel(22 + x, 12 + y, 236, 236, 0);
        gfx.PutPixel(23 + x, 12 + y, 230, 230, 0);
        gfx.PutPixel(24 + x, 12 + y, 217, 217, 0);
        gfx.PutPixel(25 + x, 12 + y, 172, 172, 0);
        gfx.PutPixel(26 + x, 12 + y, 137, 137, 0);
        gfx.PutPixel(27 + x, 12 + y, 122, 122, 0);
        gfx.PutPixel(28 + x, 12 + y, 135, 135, 15);
        gfx.PutPixel(0 + x, 13 + y, 229, 229, 7);
        gfx.PutPixel(1 + x, 13 + y, 248, 248, 59);
        gfx.PutPixel(2 + x, 13 + y, 255, 255, 53);
        gfx.PutPixel(3 + x, 13 + y, 255, 255, 8);
        gfx.PutPixel(4 + x, 13 + y, 255, 248, 14);
        gfx.PutPixel(5 + x, 13 + y, 249, 243, 117);
        gfx.PutPixel(6 + x, 13 + y, 247, 248, 203);
        gfx.PutPixel(7 + x, 13 + y, 251, 252, 160);
        gfx.PutPixel(8 + x, 13 + y, 252, 252, 146);
        gfx.PutPixel(9 + x, 13 + y, 253, 253, 219);
        gfx.PutPixel(10 + x, 13 + y, 255, 255, 255);
        gfx.PutPixel(11 + x, 13 + y, 255, 255, 255);
        gfx.PutPixel(12 + x, 13 + y, 255, 255, 255);
        gfx.PutPixel(13 + x, 13 + y, 255, 255, 255);
        gfx.PutPixel(14 + x, 13 + y, 254, 255, 221);
        gfx.PutPixel(15 + x, 13 + y, 251, 244, 180);
        gfx.PutPixel(16 + x, 13 + y, 252, 242, 175);
        gfx.PutPixel(17 + x, 13 + y, 254, 252, 160);
        gfx.PutPixel(18 + x, 13 + y, 253, 243, 59);
        gfx.PutPixel(19 + x, 13 + y, 242, 239, 4);
        gfx.PutPixel(20 + x, 13 + y, 232, 233, 0);
        gfx.PutPixel(21 + x, 13 + y, 205, 205, 0);
        gfx.PutPixel(22 + x, 13 + y, 204, 204, 39);
        gfx.PutPixel(23 + x, 13 + y, 181, 181, 27);
        gfx.PutPixel(24 + x, 13 + y, 181, 181, 27);
        gfx.PutPixel(0 + x, 14 + y, 217, 217, 26);
        gfx.PutPixel(1 + x, 14 + y, 229, 229, 93);
        gfx.PutPixel(2 + x, 14 + y, 244, 244, 84);
        gfx.PutPixel(3 + x, 14 + y, 247, 248, 9);
        gfx.PutPixel(4 + x, 14 + y, 248, 233, 46);
        gfx.PutPixel(5 + x, 14 + y, 245, 231, 156);
        gfx.PutPixel(6 + x, 14 + y, 244, 245, 207);
        gfx.PutPixel(7 + x, 14 + y, 249, 244, 152);
        gfx.PutPixel(8 + x, 14 + y, 249, 248, 167);
        gfx.PutPixel(9 + x, 14 + y, 252, 253, 207);
        gfx.PutPixel(10 + x, 14 + y, 255, 255, 228);
        gfx.PutPixel(11 + x, 14 + y, 254, 254, 235);
        gfx.PutPixel(12 + x, 14 + y, 255, 255, 253);
        gfx.PutPixel(13 + x, 14 + y, 255, 255, 255);
        gfx.PutPixel(14 + x, 14 + y, 255, 255, 232);
        gfx.PutPixel(15 + x, 14 + y, 255, 255, 224);
        gfx.PutPixel(16 + x, 14 + y, 253, 254, 241);
        gfx.PutPixel(17 + x, 14 + y, 250, 246, 226);
        gfx.PutPixel(18 + x, 14 + y, 248, 227, 118);
        gfx.PutPixel(19 + x, 14 + y, 255, 248, 24);
        gfx.PutPixel(20 + x, 14 + y, 219, 220, 0);
        gfx.PutPixel(21 + x, 14 + y, 189, 189, 38);
        gfx.PutPixel(22 + x, 14 + y, 181, 181, 27);
        gfx.PutPixel(0 + x, 15 + y, 207, 207, 20);
        gfx.PutPixel(1 + x, 15 + y, 222, 222, 0);
        gfx.PutPixel(2 + x, 15 + y, 223, 223, 0);
        gfx.PutPixel(3 + x, 15 + y, 222, 224, 1);
        gfx.PutPixel(4 + x, 15 + y, 236, 221, 61);
        gfx.PutPixel(5 + x, 15 + y, 252, 239, 107);
        gfx.PutPixel(6 + x, 15 + y, 255, 251, 102);
        gfx.PutPixel(7 + x, 15 + y, 247, 229, 109);
        gfx.PutPixel(8 + x, 15 + y, 240, 236, 220);
        gfx.PutPixel(9 + x, 15 + y, 249, 247, 165);
        gfx.PutPixel(10 + x, 15 + y, 254, 251, 125);
        gfx.PutPixel(11 + x, 15 + y, 251, 252, 180);
        gfx.PutPixel(12 + x, 15 + y, 254, 254, 246);
        gfx.PutPixel(13 + x, 15 + y, 255, 255, 255);
        gfx.PutPixel(14 + x, 15 + y, 255, 255, 172);
        gfx.PutPixel(15 + x, 15 + y, 253, 253, 128);
        gfx.PutPixel(16 + x, 15 + y, 247, 246, 173);
        gfx.PutPixel(17 + x, 15 + y, 242, 238, 205);
        gfx.PutPixel(18 + x, 15 + y, 247, 228, 109);
        gfx.PutPixel(19 + x, 15 + y, 255, 248, 29);
        gfx.PutPixel(20 + x, 15 + y, 216, 216, 0);
        gfx.PutPixel(21 + x, 15 + y, 221, 221, 135);
        gfx.PutPixel(0 + x, 16 + y, 251, 251, 68);
        gfx.PutPixel(1 + x, 16 + y, 233, 233, 23);
        gfx.PutPixel(2 + x, 16 + y, 245, 245, 13);
        gfx.PutPixel(3 + x, 16 + y, 248, 250, 80);
        gfx.PutPixel(4 + x, 16 + y, 246, 232, 99);
        gfx.PutPixel(5 + x, 16 + y, 249, 236, 60);
        gfx.PutPixel(6 + x, 16 + y, 255, 253, 16);
        gfx.PutPixel(7 + x, 16 + y, 253, 250, 34);
        gfx.PutPixel(8 + x, 16 + y, 250, 250, 134);
        gfx.PutPixel(9 + x, 16 + y, 249, 237, 120);
        gfx.PutPixel(10 + x, 16 + y, 251, 241, 161);
        gfx.PutPixel(11 + x, 16 + y, 254, 255, 243);
        gfx.PutPixel(12 + x, 16 + y, 255, 255, 253);
        gfx.PutPixel(13 + x, 16 + y, 255, 255, 254);
        gfx.PutPixel(14 + x, 16 + y, 255, 255, 235);
        gfx.PutPixel(15 + x, 16 + y, 252, 241, 155);
        gfx.PutPixel(16 + x, 16 + y, 249, 232, 128);
        gfx.PutPixel(17 + x, 16 + y, 251, 249, 157);
        gfx.PutPixel(18 + x, 16 + y, 252, 248, 48);
        gfx.PutPixel(19 + x, 16 + y, 242, 240, 67);
        gfx.PutPixel(20 + x, 16 + y, 182, 182, 38);
        gfx.PutPixel(21 + x, 16 + y, 197, 197, 122);
        gfx.PutPixel(1 + x, 17 + y, 251, 251, 68);
        gfx.PutPixel(2 + x, 17 + y, 243, 243, 57);
        gfx.PutPixel(3 + x, 17 + y, 233, 233, 27);
        gfx.PutPixel(4 + x, 17 + y, 230, 226, 32);
        gfx.PutPixel(5 + x, 17 + y, 239, 226, 45);
        gfx.PutPixel(6 + x, 17 + y, 253, 239, 53);
        gfx.PutPixel(7 + x, 17 + y, 255, 254, 9);
        gfx.PutPixel(8 + x, 17 + y, 254, 255, 31);
        gfx.PutPixel(9 + x, 17 + y, 253, 248, 89);
        gfx.PutPixel(10 + x, 17 + y, 254, 249, 147);
        gfx.PutPixel(11 + x, 17 + y, 255, 255, 196);
        gfx.PutPixel(12 + x, 17 + y, 255, 255, 243);
        gfx.PutPixel(13 + x, 17 + y, 255, 255, 222);
        gfx.PutPixel(14 + x, 17 + y, 255, 255, 120);
        gfx.PutPixel(15 + x, 17 + y, 252, 239, 79);
        gfx.PutPixel(16 + x, 17 + y, 249, 224, 108);
        gfx.PutPixel(17 + x, 17 + y, 250, 233, 115);
        gfx.PutPixel(18 + x, 17 + y, 250, 233, 76);
        gfx.PutPixel(19 + x, 17 + y, 249, 243, 42);
        gfx.PutPixel(20 + x, 17 + y, 229, 230, 10);
        gfx.PutPixel(21 + x, 17 + y, 235, 235, 129);
        gfx.PutPixel(1 + x, 18 + y, 251, 251, 68);
        gfx.PutPixel(2 + x, 18 + y, 227, 227, 82);
        gfx.PutPixel(3 + x, 18 + y, 229, 229, 0);
        gfx.PutPixel(4 + x, 18 + y, 241, 242, 0);
        gfx.PutPixel(5 + x, 18 + y, 236, 231, 50);
        gfx.PutPixel(6 + x, 18 + y, 234, 223, 96);
        gfx.PutPixel(7 + x, 18 + y, 240, 239, 10);
        gfx.PutPixel(8 + x, 18 + y, 253, 253, 0);
        gfx.PutPixel(9 + x, 18 + y, 255, 255, 37);
        gfx.PutPixel(10 + x, 18 + y, 255, 255, 61);
        gfx.PutPixel(11 + x, 18 + y, 255, 255, 109);
        gfx.PutPixel(12 + x, 18 + y, 254, 252, 229);
        gfx.PutPixel(13 + x, 18 + y, 252, 241, 169);
        gfx.PutPixel(14 + x, 18 + y, 252, 240, 71);
        gfx.PutPixel(15 + x, 18 + y, 242, 230, 38);
        gfx.PutPixel(16 + x, 18 + y, 233, 220, 47);
        gfx.PutPixel(17 + x, 18 + y, 237, 224, 46);
        gfx.PutPixel(18 + x, 18 + y, 249, 236, 51);
        gfx.PutPixel(19 + x, 18 + y, 255, 250, 63);
        gfx.PutPixel(20 + x, 18 + y, 255, 255, 23);
        gfx.PutPixel(21 + x, 18 + y, 253, 253, 64);
        gfx.PutPixel(22 + x, 18 + y, 251, 251, 68);
        gfx.PutPixel(2 + x, 19 + y, 205, 205, 74);
        gfx.PutPixel(3 + x, 19 + y, 199, 199, 0);
        gfx.PutPixel(4 + x, 19 + y, 242, 242, 0);
        gfx.PutPixel(5 + x, 19 + y, 247, 246, 37);
        gfx.PutPixel(6 + x, 19 + y, 230, 231, 69);
        gfx.PutPixel(7 + x, 19 + y, 234, 234, 8);
        gfx.PutPixel(8 + x, 19 + y, 243, 243, 0);
        gfx.PutPixel(9 + x, 19 + y, 252, 252, 0);
        gfx.PutPixel(10 + x, 19 + y, 250, 250, 11);
        gfx.PutPixel(11 + x, 19 + y, 247, 248, 74);
        gfx.PutPixel(12 + x, 19 + y, 253, 250, 153);
        gfx.PutPixel(13 + x, 19 + y, 250, 237, 89);
        gfx.PutPixel(14 + x, 19 + y, 249, 225, 89);
        gfx.PutPixel(15 + x, 19 + y, 239, 227, 46);
        gfx.PutPixel(16 + x, 19 + y, 231, 232, 0);
        gfx.PutPixel(17 + x, 19 + y, 236, 236, 0);
        gfx.PutPixel(18 + x, 19 + y, 253, 253, 1);
        gfx.PutPixel(19 + x, 19 + y, 255, 255, 67);
        gfx.PutPixel(20 + x, 19 + y, 255, 255, 65);
        gfx.PutPixel(21 + x, 19 + y, 231, 231, 10);
        gfx.PutPixel(22 + x, 19 + y, 228, 228, 126);
        gfx.PutPixel(2 + x, 20 + y, 211, 211, 120);
        gfx.PutPixel(3 + x, 20 + y, 120, 120, 2);
        gfx.PutPixel(4 + x, 20 + y, 195, 195, 0);
        gfx.PutPixel(5 + x, 20 + y, 255, 255, 0);
        gfx.PutPixel(6 + x, 20 + y, 255, 255, 0);
        gfx.PutPixel(7 + x, 20 + y, 252, 252, 0);
        gfx.PutPixel(8 + x, 20 + y, 228, 228, 0);
        gfx.PutPixel(9 + x, 20 + y, 245, 245, 0);
        gfx.PutPixel(10 + x, 20 + y, 241, 241, 54);
        gfx.PutPixel(11 + x, 20 + y, 230, 230, 79);
        gfx.PutPixel(12 + x, 20 + y, 252, 252, 0);
        gfx.PutPixel(13 + x, 20 + y, 253, 254, 0);
        gfx.PutPixel(14 + x, 20 + y, 250, 235, 71);
        gfx.PutPixel(15 + x, 20 + y, 254, 242, 52);
        gfx.PutPixel(16 + x, 20 + y, 255, 255, 0);
        gfx.PutPixel(17 + x, 20 + y, 255, 255, 0);
        gfx.PutPixel(18 + x, 20 + y, 246, 246, 0);
        gfx.PutPixel(19 + x, 20 + y, 254, 254, 0);
        gfx.PutPixel(20 + x, 20 + y, 254, 254, 65);
        gfx.PutPixel(21 + x, 20 + y, 230, 230, 76);
        gfx.PutPixel(22 + x, 20 + y, 225, 225, 108);
        gfx.PutPixel(23 + x, 20 + y, 214, 214, 58);
        gfx.PutPixel(3 + x, 21 + y, 186, 186, 78);
        gfx.PutPixel(4 + x, 21 + y, 188, 188, 0);
        gfx.PutPixel(5 + x, 21 + y, 238, 238, 0);
        gfx.PutPixel(6 + x, 21 + y, 252, 252, 0);
        gfx.PutPixel(7 + x, 21 + y, 254, 254, 0);
        gfx.PutPixel(8 + x, 21 + y, 252, 252, 0);
        gfx.PutPixel(9 + x, 21 + y, 253, 253, 0);
        gfx.PutPixel(10 + x, 21 + y, 250, 250, 5);
        gfx.PutPixel(11 + x, 21 + y, 249, 249, 22);
        gfx.PutPixel(12 + x, 21 + y, 250, 250, 37);
        gfx.PutPixel(13 + x, 21 + y, 228, 228, 5);
        gfx.PutPixel(14 + x, 21 + y, 243, 240, 78);
        gfx.PutPixel(15 + x, 21 + y, 252, 250, 61);
        gfx.PutPixel(16 + x, 21 + y, 246, 247, 0);
        gfx.PutPixel(17 + x, 21 + y, 230, 230, 0);
        gfx.PutPixel(18 + x, 21 + y, 183, 183, 0);
        gfx.PutPixel(19 + x, 21 + y, 222, 222, 0);
        gfx.PutPixel(20 + x, 21 + y, 240, 240, 9);
        gfx.PutPixel(21 + x, 21 + y, 224, 224, 10);
        gfx.PutPixel(22 + x, 21 + y, 199, 199, 5);
        gfx.PutPixel(23 + x, 21 + y, 203, 203, 104);
        gfx.PutPixel(24 + x, 21 + y, 214, 214, 58);
        gfx.PutPixel(2 + x, 22 + y, 166, 166, 18);
        gfx.PutPixel(3 + x, 22 + y, 166, 166, 18);
        gfx.PutPixel(4 + x, 22 + y, 167, 167, 0);
        gfx.PutPixel(5 + x, 22 + y, 191, 191, 0);
        gfx.PutPixel(6 + x, 22 + y, 221, 221, 0);
        gfx.PutPixel(7 + x, 22 + y, 251, 251, 0);
        gfx.PutPixel(8 + x, 22 + y, 255, 255, 0);
        gfx.PutPixel(9 + x, 22 + y, 241, 241, 0);
        gfx.PutPixel(10 + x, 22 + y, 230, 230, 0);
        gfx.PutPixel(11 + x, 22 + y, 240, 240, 54);
        gfx.PutPixel(12 + x, 22 + y, 245, 245, 113);
        gfx.PutPixel(13 + x, 22 + y, 196, 196, 34);
        gfx.PutPixel(14 + x, 22 + y, 229, 230, 15);
        gfx.PutPixel(15 + x, 22 + y, 219, 220, 46);
        gfx.PutPixel(16 + x, 22 + y, 176, 176, 43);
        gfx.PutPixel(17 + x, 22 + y, 163, 163, 3);
        gfx.PutPixel(18 + x, 22 + y, 158, 158, 0);
        gfx.PutPixel(19 + x, 22 + y, 176, 176, 0);
        gfx.PutPixel(20 + x, 22 + y, 206, 206, 0);
        gfx.PutPixel(21 + x, 22 + y, 213, 213, 0);
        gfx.PutPixel(22 + x, 22 + y, 163, 163, 0);
        gfx.PutPixel(23 + x, 22 + y, 148, 148, 25);
        gfx.PutPixel(24 + x, 22 + y, 214, 214, 58);
        gfx.PutPixel(2 + x, 23 + y, 181, 181, 27);
        gfx.PutPixel(3 + x, 23 + y, 139, 139, 54);
        gfx.PutPixel(4 + x, 23 + y, 122, 122, 0);
        gfx.PutPixel(5 + x, 23 + y, 165, 165, 0);
        gfx.PutPixel(6 + x, 23 + y, 200, 200, 0);
        gfx.PutPixel(7 + x, 23 + y, 218, 218, 0);
        gfx.PutPixel(8 + x, 23 + y, 223, 223, 0);
        gfx.PutPixel(9 + x, 23 + y, 196, 196, 0);
        gfx.PutPixel(10 + x, 23 + y, 236, 236, 109);
        gfx.PutPixel(11 + x, 23 + y, 232, 232, 35);
        gfx.PutPixel(12 + x, 23 + y, 235, 235, 62);
        gfx.PutPixel(13 + x, 23 + y, 251, 251, 68);
        gfx.PutPixel(14 + x, 23 + y, 214, 214, 58);
        gfx.PutPixel(15 + x, 23 + y, 235, 235, 134);
        gfx.PutPixel(16 + x, 23 + y, 214, 214, 58);
        gfx.PutPixel(17 + x, 23 + y, 214, 214, 58);
        gfx.PutPixel(18 + x, 23 + y, 214, 214, 58);
        gfx.PutPixel(19 + x, 23 + y, 214, 214, 58);
        gfx.PutPixel(20 + x, 23 + y, 232, 232, 128);
        gfx.PutPixel(21 + x, 23 + y, 154, 154, 0);
        gfx.PutPixel(22 + x, 23 + y, 168, 168, 44);
        gfx.PutPixel(23 + x, 23 + y, 214, 214, 58);
        gfx.PutPixel(24 + x, 23 + y, 214, 214, 58);
        gfx.PutPixel(3 + x, 24 + y, 166, 166, 18);
        gfx.PutPixel(4 + x, 24 + y, 146, 146, 76);
        gfx.PutPixel(5 + x, 24 + y, 131, 131, 0);
        gfx.PutPixel(6 + x, 24 + y, 181, 181, 0);
        gfx.PutPixel(7 + x, 24 + y, 198, 198, 0);
        gfx.PutPixel(8 + x, 24 + y, 195, 195, 0);
        gfx.PutPixel(9 + x, 24 + y, 153, 153, 0);
        gfx.PutPixel(10 + x, 24 + y, 251, 251, 68);
        gfx.PutPixel(11 + x, 24 + y, 251, 251, 68);
        gfx.PutPixel(12 + x, 24 + y, 251, 251, 68);
        gfx.PutPixel(14 + x, 24 + y, 251, 251, 68);
        gfx.PutPixel(15 + x, 24 + y, 251, 251, 68);
        gfx.PutPixel(20 + x, 24 + y, 214, 214, 58);
        gfx.PutPixel(21 + x, 24 + y, 214, 214, 58);
        gfx.PutPixel(22 + x, 24 + y, 214, 214, 58);
        gfx.PutPixel(4 + x, 25 + y, 166, 166, 18);
        gfx.PutPixel(5 + x, 25 + y, 120, 120, 29);
        gfx.PutPixel(6 + x, 25 + y, 141, 141, 0);
        gfx.PutPixel(7 + x, 25 + y, 207, 207, 12);
        gfx.PutPixel(8 + x, 25 + y, 201, 201, 2);
        gfx.PutPixel(9 + x, 25 + y, 131, 131, 0);
        gfx.PutPixel(10 + x, 25 + y, 251, 251, 68);
        gfx.PutPixel(4 + x, 26 + y, 166, 166, 18);
        gfx.PutPixel(5 + x, 26 + y, 166, 166, 18);
        gfx.PutPixel(6 + x, 26 + y, 126, 126, 0);
        gfx.PutPixel(7 + x, 26 + y, 185, 185, 57);
        gfx.PutPixel(8 + x, 26 + y, 186, 186, 7);
        gfx.PutPixel(9 + x, 26 + y, 159, 159, 14);
        gfx.PutPixel(10 + x, 26 + y, 251, 251, 68);
        gfx.PutPixel(5 + x, 27 + y, 166, 166, 18);
        gfx.PutPixel(6 + x, 27 + y, 128, 128, 0);
        gfx.PutPixel(7 + x, 27 + y, 157, 157, 15);
        gfx.PutPixel(8 + x, 27 + y, 149, 149, 5);
        gfx.PutPixel(9 + x, 27 + y, 251, 251, 68);
        gfx.PutPixel(6 + x, 28 + y, 166, 166, 18);
        gfx.PutPixel(7 + x, 28 + y, 169, 169, 70);
        gfx.PutPixel(8 + x, 28 + y, 251, 251, 68);

    }

    if (animation_status >= 20 && animation_status < 30)
    {
        gfx.PutPixel(13 + x, 0 + y, 251, 251, 68);
        gfx.PutPixel(14 + x, 0 + y, 207, 207, 20);
        gfx.PutPixel(15 + x, 0 + y, 217, 217, 26);
        gfx.PutPixel(16 + x, 0 + y, 229, 229, 7);
        gfx.PutPixel(17 + x, 0 + y, 243, 243, 103);
        gfx.PutPixel(18 + x, 0 + y, 251, 251, 68);
        gfx.PutPixel(11 + x, 1 + y, 251, 251, 68);
        gfx.PutPixel(12 + x, 1 + y, 251, 251, 68);
        gfx.PutPixel(13 + x, 1 + y, 233, 233, 23);
        gfx.PutPixel(14 + x, 1 + y, 222, 222, 0);
        gfx.PutPixel(15 + x, 1 + y, 229, 229, 93);
        gfx.PutPixel(16 + x, 1 + y, 248, 248, 59);
        gfx.PutPixel(17 + x, 1 + y, 218, 218, 0);
        gfx.PutPixel(18 + x, 1 + y, 222, 222, 106);
        gfx.PutPixel(19 + x, 1 + y, 251, 251, 68);
        gfx.PutPixel(6 + x, 2 + y, 181, 181, 27);
        gfx.PutPixel(7 + x, 2 + y, 166, 166, 18);
        gfx.PutPixel(9 + x, 2 + y, 211, 211, 120);
        gfx.PutPixel(10 + x, 2 + y, 205, 205, 74);
        gfx.PutPixel(11 + x, 2 + y, 227, 227, 82);
        gfx.PutPixel(12 + x, 2 + y, 243, 243, 57);
        gfx.PutPixel(13 + x, 2 + y, 245, 245, 13);
        gfx.PutPixel(14 + x, 2 + y, 223, 223, 0);
        gfx.PutPixel(15 + x, 2 + y, 244, 244, 84);
        gfx.PutPixel(16 + x, 2 + y, 255, 255, 53);
        gfx.PutPixel(17 + x, 2 + y, 222, 222, 0);
        gfx.PutPixel(18 + x, 2 + y, 230, 230, 121);
        gfx.PutPixel(5 + x, 3 + y, 166, 166, 18);
        gfx.PutPixel(6 + x, 3 + y, 139, 139, 54);
        gfx.PutPixel(7 + x, 3 + y, 166, 166, 18);
        gfx.PutPixel(8 + x, 3 + y, 186, 186, 78);
        gfx.PutPixel(9 + x, 3 + y, 120, 120, 2);
        gfx.PutPixel(10 + x, 3 + y, 199, 199, 0);
        gfx.PutPixel(11 + x, 3 + y, 229, 229, 0);
        gfx.PutPixel(12 + x, 3 + y, 233, 233, 27);
        gfx.PutPixel(13 + x, 3 + y, 248, 250, 80);
        gfx.PutPixel(14 + x, 3 + y, 222, 224, 1);
        gfx.PutPixel(15 + x, 3 + y, 247, 248, 9);
        gfx.PutPixel(16 + x, 3 + y, 255, 255, 8);
        gfx.PutPixel(17 + x, 3 + y, 240, 240, 0);
        gfx.PutPixel(18 + x, 3 + y, 234, 234, 57);
        gfx.PutPixel(19 + x, 3 + y, 251, 251, 68);
        gfx.PutPixel(3 + x, 4 + y, 166, 166, 18);
        gfx.PutPixel(4 + x, 4 + y, 166, 166, 18);
        gfx.PutPixel(5 + x, 4 + y, 146, 146, 76);
        gfx.PutPixel(6 + x, 4 + y, 122, 122, 0);
        gfx.PutPixel(7 + x, 4 + y, 167, 167, 0);
        gfx.PutPixel(8 + x, 4 + y, 188, 188, 0);
        gfx.PutPixel(9 + x, 4 + y, 195, 195, 0);
        gfx.PutPixel(10 + x, 4 + y, 242, 242, 0);
        gfx.PutPixel(11 + x, 4 + y, 241, 242, 0);
        gfx.PutPixel(12 + x, 4 + y, 230, 226, 32);
        gfx.PutPixel(13 + x, 4 + y, 246, 232, 99);
        gfx.PutPixel(14 + x, 4 + y, 236, 221, 61);
        gfx.PutPixel(15 + x, 4 + y, 248, 233, 46);
        gfx.PutPixel(16 + x, 4 + y, 255, 248, 14);
        gfx.PutPixel(17 + x, 4 + y, 245, 246, 0);
        gfx.PutPixel(18 + x, 4 + y, 232, 232, 36);
        gfx.PutPixel(19 + x, 4 + y, 233, 233, 61);
        gfx.PutPixel(20 + x, 4 + y, 237, 237, 84);
        gfx.PutPixel(21 + x, 4 + y, 239, 239, 107);
        gfx.PutPixel(22 + x, 4 + y, 239, 239, 110);
        gfx.PutPixel(23 + x, 4 + y, 251, 251, 68);
        gfx.PutPixel(2 + x, 5 + y, 166, 166, 18);
        gfx.PutPixel(3 + x, 5 + y, 166, 166, 18);
        gfx.PutPixel(4 + x, 5 + y, 120, 120, 29);
        gfx.PutPixel(5 + x, 5 + y, 131, 131, 0);
        gfx.PutPixel(6 + x, 5 + y, 165, 165, 0);
        gfx.PutPixel(7 + x, 5 + y, 191, 191, 0);
        gfx.PutPixel(8 + x, 5 + y, 238, 238, 0);
        gfx.PutPixel(9 + x, 5 + y, 255, 255, 0);
        gfx.PutPixel(10 + x, 5 + y, 247, 246, 37);
        gfx.PutPixel(11 + x, 5 + y, 236, 231, 50);
        gfx.PutPixel(12 + x, 5 + y, 239, 226, 45);
        gfx.PutPixel(13 + x, 5 + y, 249, 236, 60);
        gfx.PutPixel(14 + x, 5 + y, 252, 239, 107);
        gfx.PutPixel(15 + x, 5 + y, 245, 231, 156);
        gfx.PutPixel(16 + x, 5 + y, 249, 243, 117);
        gfx.PutPixel(17 + x, 5 + y, 249, 250, 35);
        gfx.PutPixel(18 + x, 5 + y, 246, 246, 57);
        gfx.PutPixel(19 + x, 5 + y, 244, 244, 124);
        gfx.PutPixel(20 + x, 5 + y, 233, 233, 90);
        gfx.PutPixel(21 + x, 5 + y, 242, 242, 145);
        gfx.PutPixel(22 + x, 5 + y, 243, 243, 160);
        gfx.PutPixel(23 + x, 5 + y, 251, 251, 68);
        gfx.PutPixel(1 + x, 6 + y, 166, 166, 18);
        gfx.PutPixel(2 + x, 6 + y, 128, 128, 0);
        gfx.PutPixel(3 + x, 6 + y, 126, 126, 0);
        gfx.PutPixel(4 + x, 6 + y, 141, 141, 0);
        gfx.PutPixel(5 + x, 6 + y, 181, 181, 0);
        gfx.PutPixel(6 + x, 6 + y, 200, 200, 0);
        gfx.PutPixel(7 + x, 6 + y, 221, 221, 0);
        gfx.PutPixel(8 + x, 6 + y, 252, 252, 0);
        gfx.PutPixel(9 + x, 6 + y, 255, 255, 0);
        gfx.PutPixel(10 + x, 6 + y, 230, 231, 69);
        gfx.PutPixel(11 + x, 6 + y, 234, 223, 96);
        gfx.PutPixel(12 + x, 6 + y, 253, 239, 53);
        gfx.PutPixel(13 + x, 6 + y, 255, 253, 16);
        gfx.PutPixel(14 + x, 6 + y, 255, 251, 102);
        gfx.PutPixel(15 + x, 6 + y, 244, 245, 207);
        gfx.PutPixel(16 + x, 6 + y, 247, 248, 203);
        gfx.PutPixel(17 + x, 6 + y, 253, 251, 115);
        gfx.PutPixel(18 + x, 6 + y, 255, 251, 16);
        gfx.PutPixel(19 + x, 6 + y, 255, 255, 0);
        gfx.PutPixel(20 + x, 6 + y, 212, 213, 0);
        gfx.PutPixel(21 + x, 6 + y, 232, 232, 0);
        gfx.PutPixel(22 + x, 6 + y, 222, 223, 0);
        gfx.PutPixel(23 + x, 6 + y, 230, 231, 89);
        gfx.PutPixel(24 + x, 6 + y, 251, 251, 68);
        gfx.PutPixel(25 + x, 6 + y, 251, 251, 68);
        gfx.PutPixel(26 + x, 6 + y, 196, 196, 136);
        gfx.PutPixel(27 + x, 6 + y, 162, 162, 93);
        gfx.PutPixel(1 + x, 7 + y, 169, 169, 70);
        gfx.PutPixel(2 + x, 7 + y, 157, 157, 15);
        gfx.PutPixel(3 + x, 7 + y, 185, 185, 57);
        gfx.PutPixel(4 + x, 7 + y, 207, 207, 12);
        gfx.PutPixel(5 + x, 7 + y, 198, 198, 0);
        gfx.PutPixel(6 + x, 7 + y, 218, 218, 0);
        gfx.PutPixel(7 + x, 7 + y, 251, 251, 0);
        gfx.PutPixel(8 + x, 7 + y, 254, 254, 0);
        gfx.PutPixel(9 + x, 7 + y, 252, 252, 0);
        gfx.PutPixel(10 + x, 7 + y, 234, 234, 8);
        gfx.PutPixel(11 + x, 7 + y, 240, 239, 10);
        gfx.PutPixel(12 + x, 7 + y, 255, 254, 9);
        gfx.PutPixel(13 + x, 7 + y, 253, 250, 34);
        gfx.PutPixel(14 + x, 7 + y, 247, 229, 109);
        gfx.PutPixel(15 + x, 7 + y, 249, 244, 152);
        gfx.PutPixel(16 + x, 7 + y, 251, 252, 160);
        gfx.PutPixel(17 + x, 7 + y, 251, 244, 135);
        gfx.PutPixel(18 + x, 7 + y, 250, 236, 84);
        gfx.PutPixel(19 + x, 7 + y, 255, 255, 28);
        gfx.PutPixel(20 + x, 7 + y, 249, 246, 14);
        gfx.PutPixel(21 + x, 7 + y, 252, 250, 16);
        gfx.PutPixel(22 + x, 7 + y, 251, 250, 16);
        gfx.PutPixel(23 + x, 7 + y, 245, 243, 19);
        gfx.PutPixel(24 + x, 7 + y, 251, 251, 68);
        gfx.PutPixel(25 + x, 7 + y, 240, 240, 69);
        gfx.PutPixel(26 + x, 7 + y, 193, 193, 30);
        gfx.PutPixel(27 + x, 7 + y, 161, 161, 21);
        gfx.PutPixel(28 + x, 7 + y, 218, 217, 12);
        gfx.PutPixel(1 + x, 8 + y, 251, 251, 68);
        gfx.PutPixel(2 + x, 8 + y, 149, 149, 5);
        gfx.PutPixel(3 + x, 8 + y, 186, 186, 7);
        gfx.PutPixel(4 + x, 8 + y, 201, 201, 2);
        gfx.PutPixel(5 + x, 8 + y, 195, 195, 0);
        gfx.PutPixel(6 + x, 8 + y, 223, 223, 0);
        gfx.PutPixel(7 + x, 8 + y, 255, 255, 0);
        gfx.PutPixel(8 + x, 8 + y, 252, 252, 0);
        gfx.PutPixel(9 + x, 8 + y, 228, 228, 0);
        gfx.PutPixel(10 + x, 8 + y, 243, 243, 0);
        gfx.PutPixel(11 + x, 8 + y, 253, 253, 0);
        gfx.PutPixel(12 + x, 8 + y, 254, 255, 31);
        gfx.PutPixel(13 + x, 8 + y, 250, 250, 134);
        gfx.PutPixel(14 + x, 8 + y, 240, 236, 220);
        gfx.PutPixel(15 + x, 8 + y, 249, 248, 167);
        gfx.PutPixel(16 + x, 8 + y, 252, 252, 146);
        gfx.PutPixel(17 + x, 8 + y, 251, 249, 147);
        gfx.PutPixel(18 + x, 8 + y, 252, 248, 146);
        gfx.PutPixel(19 + x, 8 + y, 255, 255, 165);
        gfx.PutPixel(20 + x, 8 + y, 250, 234, 97);
        gfx.PutPixel(21 + x, 8 + y, 251, 242, 110);
        gfx.PutPixel(22 + x, 8 + y, 253, 246, 121);
        gfx.PutPixel(23 + x, 8 + y, 246, 230, 65);
        gfx.PutPixel(24 + x, 8 + y, 228, 227, 0);
        gfx.PutPixel(25 + x, 8 + y, 222, 222, 0);
        gfx.PutPixel(26 + x, 8 + y, 232, 232, 66);
        gfx.PutPixel(27 + x, 8 + y, 226, 226, 66);
        gfx.PutPixel(28 + x, 8 + y, 208, 208, 10);
        gfx.PutPixel(29 + x, 8 + y, 218, 218, 94);
        gfx.PutPixel(2 + x, 9 + y, 251, 251, 68);
        gfx.PutPixel(3 + x, 9 + y, 159, 159, 14);
        gfx.PutPixel(4 + x, 9 + y, 131, 131, 0);
        gfx.PutPixel(5 + x, 9 + y, 153, 153, 0);
        gfx.PutPixel(6 + x, 9 + y, 196, 196, 0);
        gfx.PutPixel(7 + x, 9 + y, 241, 241, 0);
        gfx.PutPixel(8 + x, 9 + y, 253, 253, 0);
        gfx.PutPixel(9 + x, 9 + y, 245, 245, 0);
        gfx.PutPixel(10 + x, 9 + y, 252, 252, 0);
        gfx.PutPixel(11 + x, 9 + y, 255, 255, 37);
        gfx.PutPixel(12 + x, 9 + y, 253, 248, 89);
        gfx.PutPixel(13 + x, 9 + y, 249, 237, 120);
        gfx.PutPixel(14 + x, 9 + y, 249, 247, 165);
        gfx.PutPixel(15 + x, 9 + y, 252, 253, 207);
        gfx.PutPixel(16 + x, 9 + y, 253, 253, 219);
        gfx.PutPixel(17 + x, 9 + y, 253, 253, 203);
        gfx.PutPixel(18 + x, 9 + y, 253, 254, 183);
        gfx.PutPixel(19 + x, 9 + y, 255, 255, 203);
        gfx.PutPixel(20 + x, 9 + y, 250, 242, 154);
        gfx.PutPixel(21 + x, 9 + y, 252, 249, 93);
        gfx.PutPixel(22 + x, 9 + y, 246, 242, 50);
        gfx.PutPixel(23 + x, 9 + y, 234, 226, 51);
        gfx.PutPixel(24 + x, 9 + y, 240, 241, 86);
        gfx.PutPixel(25 + x, 9 + y, 243, 243, 15);
        gfx.PutPixel(26 + x, 9 + y, 252, 252, 31);
        gfx.PutPixel(27 + x, 9 + y, 246, 246, 25);
        gfx.PutPixel(28 + x, 9 + y, 248, 248, 87);
        gfx.PutPixel(29 + x, 9 + y, 221, 221, 190);
        gfx.PutPixel(3 + x, 10 + y, 251, 251, 68);
        gfx.PutPixel(4 + x, 10 + y, 251, 251, 68);
        gfx.PutPixel(5 + x, 10 + y, 251, 251, 68);
        gfx.PutPixel(6 + x, 10 + y, 236, 236, 109);
        gfx.PutPixel(7 + x, 10 + y, 230, 230, 0);
        gfx.PutPixel(8 + x, 10 + y, 250, 250, 5);
        gfx.PutPixel(9 + x, 10 + y, 241, 241, 54);
        gfx.PutPixel(10 + x, 10 + y, 250, 250, 11);
        gfx.PutPixel(11 + x, 10 + y, 255, 255, 61);
        gfx.PutPixel(12 + x, 10 + y, 254, 249, 147);
        gfx.PutPixel(13 + x, 10 + y, 251, 241, 161);
        gfx.PutPixel(14 + x, 10 + y, 254, 251, 125);
        gfx.PutPixel(15 + x, 10 + y, 255, 255, 228);
        gfx.PutPixel(16 + x, 10 + y, 255, 255, 255);
        gfx.PutPixel(17 + x, 10 + y, 255, 255, 250);
        gfx.PutPixel(18 + x, 10 + y, 255, 255, 214);
        gfx.PutPixel(19 + x, 10 + y, 255, 255, 167);
        gfx.PutPixel(20 + x, 10 + y, 254, 255, 91);
        gfx.PutPixel(21 + x, 10 + y, 255, 255, 22);
        gfx.PutPixel(22 + x, 10 + y, 248, 249, 0);
        gfx.PutPixel(23 + x, 10 + y, 243, 243, 11);
        gfx.PutPixel(24 + x, 10 + y, 255, 255, 71);
        gfx.PutPixel(25 + x, 10 + y, 255, 255, 12);
        gfx.PutPixel(26 + x, 10 + y, 255, 255, 0);
        gfx.PutPixel(27 + x, 10 + y, 230, 230, 0);
        gfx.PutPixel(28 + x, 10 + y, 209, 209, 69);
        gfx.PutPixel(29 + x, 10 + y, 251, 251, 68);
        gfx.PutPixel(5 + x, 11 + y, 251, 251, 68);
        gfx.PutPixel(6 + x, 11 + y, 232, 232, 35);
        gfx.PutPixel(7 + x, 11 + y, 240, 240, 54);
        gfx.PutPixel(8 + x, 11 + y, 249, 249, 22);
        gfx.PutPixel(9 + x, 11 + y, 230, 230, 79);
        gfx.PutPixel(10 + x, 11 + y, 247, 248, 74);
        gfx.PutPixel(11 + x, 11 + y, 255, 255, 109);
        gfx.PutPixel(12 + x, 11 + y, 255, 255, 196);
        gfx.PutPixel(13 + x, 11 + y, 254, 255, 243);
        gfx.PutPixel(14 + x, 11 + y, 251, 252, 180);
        gfx.PutPixel(15 + x, 11 + y, 254, 254, 235);
        gfx.PutPixel(16 + x, 11 + y, 255, 255, 255);
        gfx.PutPixel(17 + x, 11 + y, 254, 254, 255);
        gfx.PutPixel(18 + x, 11 + y, 251, 251, 239);
        gfx.PutPixel(19 + x, 11 + y, 255, 255, 168);
        gfx.PutPixel(20 + x, 11 + y, 255, 255, 75);
        gfx.PutPixel(21 + x, 11 + y, 254, 254, 44);
        gfx.PutPixel(22 + x, 11 + y, 255, 255, 24);
        gfx.PutPixel(23 + x, 11 + y, 255, 255, 0);
        gfx.PutPixel(24 + x, 11 + y, 255, 255, 0);
        gfx.PutPixel(25 + x, 11 + y, 255, 255, 0);
        gfx.PutPixel(26 + x, 11 + y, 251, 252, 0);
        gfx.PutPixel(27 + x, 11 + y, 206, 206, 0);
        gfx.PutPixel(28 + x, 11 + y, 154, 154, 22);
        gfx.PutPixel(29 + x, 11 + y, 161, 161, 104);
        gfx.PutPixel(5 + x, 12 + y, 251, 251, 68);
        gfx.PutPixel(6 + x, 12 + y, 235, 235, 62);
        gfx.PutPixel(7 + x, 12 + y, 245, 245, 113);
        gfx.PutPixel(8 + x, 12 + y, 250, 250, 37);
        gfx.PutPixel(9 + x, 12 + y, 252, 252, 0);
        gfx.PutPixel(10 + x, 12 + y, 253, 250, 153);
        gfx.PutPixel(11 + x, 12 + y, 254, 252, 229);
        gfx.PutPixel(12 + x, 12 + y, 255, 255, 243);
        gfx.PutPixel(13 + x, 12 + y, 255, 255, 253);
        gfx.PutPixel(14 + x, 12 + y, 254, 254, 246);
        gfx.PutPixel(15 + x, 12 + y, 255, 255, 253);
        gfx.PutPixel(16 + x, 12 + y, 255, 255, 255);
        gfx.PutPixel(17 + x, 12 + y, 251, 251, 246);
        gfx.PutPixel(18 + x, 12 + y, 246, 246, 226);
        gfx.PutPixel(19 + x, 12 + y, 253, 254, 231);
        gfx.PutPixel(20 + x, 12 + y, 255, 255, 218);
        gfx.PutPixel(21 + x, 12 + y, 253, 254, 160);
        gfx.PutPixel(22 + x, 12 + y, 253, 252, 76);
        gfx.PutPixel(23 + x, 12 + y, 253, 250, 20);
        gfx.PutPixel(24 + x, 12 + y, 253, 250, 13);
        gfx.PutPixel(25 + x, 12 + y, 254, 250, 14);
        gfx.PutPixel(26 + x, 12 + y, 242, 240, 5);
        gfx.PutPixel(27 + x, 12 + y, 187, 187, 0);
        gfx.PutPixel(28 + x, 12 + y, 194, 194, 100);
        gfx.PutPixel(29 + x, 12 + y, 218, 217, 12);
        gfx.PutPixel(6 + x, 13 + y, 251, 251, 68);
        gfx.PutPixel(7 + x, 13 + y, 196, 196, 34);
        gfx.PutPixel(8 + x, 13 + y, 228, 228, 5);
        gfx.PutPixel(9 + x, 13 + y, 253, 254, 0);
        gfx.PutPixel(10 + x, 13 + y, 250, 237, 89);
        gfx.PutPixel(11 + x, 13 + y, 252, 241, 169);
        gfx.PutPixel(12 + x, 13 + y, 255, 255, 222);
        gfx.PutPixel(13 + x, 13 + y, 255, 255, 254);
        gfx.PutPixel(14 + x, 13 + y, 255, 255, 255);
        gfx.PutPixel(15 + x, 13 + y, 255, 255, 255);
        gfx.PutPixel(16 + x, 13 + y, 255, 255, 255);
        gfx.PutPixel(17 + x, 13 + y, 254, 254, 220);
        gfx.PutPixel(18 + x, 13 + y, 252, 252, 155);
        gfx.PutPixel(19 + x, 13 + y, 252, 252, 170);
        gfx.PutPixel(20 + x, 13 + y, 254, 254, 156);
        gfx.PutPixel(21 + x, 13 + y, 255, 255, 75);
        gfx.PutPixel(22 + x, 13 + y, 253, 245, 38);
        gfx.PutPixel(23 + x, 13 + y, 249, 229, 79);
        gfx.PutPixel(24 + x, 13 + y, 248, 227, 83);
        gfx.PutPixel(25 + x, 13 + y, 248, 229, 81);
        gfx.PutPixel(26 + x, 13 + y, 251, 243, 31);
        gfx.PutPixel(27 + x, 13 + y, 212, 213, 0);
        gfx.PutPixel(28 + x, 13 + y, 161, 161, 17);
        gfx.PutPixel(29 + x, 13 + y, 180, 180, 102);
        gfx.PutPixel(5 + x, 14 + y, 251, 251, 68);
        gfx.PutPixel(6 + x, 14 + y, 214, 214, 58);
        gfx.PutPixel(7 + x, 14 + y, 229, 230, 15);
        gfx.PutPixel(8 + x, 14 + y, 243, 240, 78);
        gfx.PutPixel(9 + x, 14 + y, 250, 235, 71);
        gfx.PutPixel(10 + x, 14 + y, 249, 225, 89);
        gfx.PutPixel(11 + x, 14 + y, 252, 240, 71);
        gfx.PutPixel(12 + x, 14 + y, 255, 255, 120);
        gfx.PutPixel(13 + x, 14 + y, 255, 255, 235);
        gfx.PutPixel(14 + x, 14 + y, 255, 255, 172);
        gfx.PutPixel(15 + x, 14 + y, 255, 255, 232);
        gfx.PutPixel(16 + x, 14 + y, 254, 255, 221);
        gfx.PutPixel(17 + x, 14 + y, 254, 255, 199);
        gfx.PutPixel(18 + x, 14 + y, 253, 250, 197);
        gfx.PutPixel(19 + x, 14 + y, 249, 231, 128);
        gfx.PutPixel(20 + x, 14 + y, 253, 250, 50);
        gfx.PutPixel(21 + x, 14 + y, 241, 242, 56);
        gfx.PutPixel(22 + x, 14 + y, 239, 236, 64);
        gfx.PutPixel(23 + x, 14 + y, 252, 245, 36);
        gfx.PutPixel(24 + x, 14 + y, 254, 246, 32);
        gfx.PutPixel(25 + x, 14 + y, 248, 227, 86);
        gfx.PutPixel(26 + x, 14 + y, 254, 244, 40);
        gfx.PutPixel(27 + x, 14 + y, 229, 230, 0);
        gfx.PutPixel(28 + x, 14 + y, 161, 161, 0);
        gfx.PutPixel(29 + x, 14 + y, 126, 126, 60);
        gfx.PutPixel(5 + x, 15 + y, 251, 251, 68);
        gfx.PutPixel(6 + x, 15 + y, 235, 235, 134);
        gfx.PutPixel(7 + x, 15 + y, 219, 220, 46);
        gfx.PutPixel(8 + x, 15 + y, 252, 250, 61);
        gfx.PutPixel(9 + x, 15 + y, 254, 242, 52);
        gfx.PutPixel(10 + x, 15 + y, 239, 227, 46);
        gfx.PutPixel(11 + x, 15 + y, 242, 230, 38);
        gfx.PutPixel(12 + x, 15 + y, 252, 239, 79);
        gfx.PutPixel(13 + x, 15 + y, 252, 241, 155);
        gfx.PutPixel(14 + x, 15 + y, 253, 253, 128);
        gfx.PutPixel(15 + x, 15 + y, 255, 255, 224);
        gfx.PutPixel(16 + x, 15 + y, 251, 244, 180);
        gfx.PutPixel(17 + x, 15 + y, 251, 241, 139);
        gfx.PutPixel(18 + x, 15 + y, 254, 251, 163);
        gfx.PutPixel(19 + x, 15 + y, 252, 239, 48);
        gfx.PutPixel(20 + x, 15 + y, 254, 251, 56);
        gfx.PutPixel(21 + x, 15 + y, 245, 246, 63);
        gfx.PutPixel(22 + x, 15 + y, 237, 238, 36);
        gfx.PutPixel(23 + x, 15 + y, 239, 240, 0);
        gfx.PutPixel(24 + x, 15 + y, 237, 240, 0);
        gfx.PutPixel(25 + x, 15 + y, 246, 227, 76);
        gfx.PutPixel(26 + x, 15 + y, 254, 244, 40);
        gfx.PutPixel(27 + x, 15 + y, 235, 236, 0);
        gfx.PutPixel(28 + x, 15 + y, 172, 172, 0);
        gfx.PutPixel(29 + x, 15 + y, 135, 135, 58);
        gfx.PutPixel(6 + x, 16 + y, 214, 214, 58);
        gfx.PutPixel(7 + x, 16 + y, 176, 176, 43);
        gfx.PutPixel(8 + x, 16 + y, 246, 247, 0);
        gfx.PutPixel(9 + x, 16 + y, 255, 255, 0);
        gfx.PutPixel(10 + x, 16 + y, 231, 232, 0);
        gfx.PutPixel(11 + x, 16 + y, 233, 220, 47);
        gfx.PutPixel(12 + x, 16 + y, 249, 224, 108);
        gfx.PutPixel(13 + x, 16 + y, 249, 232, 128);
        gfx.PutPixel(14 + x, 16 + y, 247, 246, 173);
        gfx.PutPixel(15 + x, 16 + y, 253, 254, 241);
        gfx.PutPixel(16 + x, 16 + y, 252, 242, 175);
        gfx.PutPixel(17 + x, 16 + y, 250, 235, 100);
        gfx.PutPixel(18 + x, 16 + y, 251, 244, 96);
        gfx.PutPixel(19 + x, 16 + y, 245, 246, 28);
        gfx.PutPixel(20 + x, 16 + y, 253, 254, 82);
        gfx.PutPixel(21 + x, 16 + y, 255, 255, 39);
        gfx.PutPixel(22 + x, 16 + y, 248, 248, 0);
        gfx.PutPixel(23 + x, 16 + y, 232, 231, 5);
        gfx.PutPixel(24 + x, 16 + y, 229, 222, 25);
        gfx.PutPixel(25 + x, 16 + y, 238, 224, 90);
        gfx.PutPixel(26 + x, 16 + y, 247, 240, 41);
        gfx.PutPixel(27 + x, 16 + y, 216, 217, 0);
        gfx.PutPixel(28 + x, 16 + y, 181, 181, 27);
        gfx.PutPixel(29 + x, 16 + y, 218, 217, 12);
        gfx.PutPixel(6 + x, 17 + y, 214, 214, 58);
        gfx.PutPixel(7 + x, 17 + y, 163, 163, 3);
        gfx.PutPixel(8 + x, 17 + y, 230, 230, 0);
        gfx.PutPixel(9 + x, 17 + y, 255, 255, 0);
        gfx.PutPixel(10 + x, 17 + y, 236, 236, 0);
        gfx.PutPixel(11 + x, 17 + y, 237, 224, 46);
        gfx.PutPixel(12 + x, 17 + y, 250, 233, 115);
        gfx.PutPixel(13 + x, 17 + y, 251, 249, 157);
        gfx.PutPixel(14 + x, 17 + y, 242, 238, 205);
        gfx.PutPixel(15 + x, 17 + y, 250, 246, 226);
        gfx.PutPixel(16 + x, 17 + y, 254, 252, 160);
        gfx.PutPixel(17 + x, 17 + y, 253, 247, 97);
        gfx.PutPixel(18 + x, 17 + y, 246, 232, 101);
        gfx.PutPixel(19 + x, 17 + y, 231, 230, 89);
        gfx.PutPixel(20 + x, 17 + y, 245, 245, 25);
        gfx.PutPixel(21 + x, 17 + y, 253, 253, 1);
        gfx.PutPixel(22 + x, 17 + y, 254, 255, 0);
        gfx.PutPixel(23 + x, 17 + y, 247, 244, 14);
        gfx.PutPixel(24 + x, 17 + y, 243, 225, 65);
        gfx.PutPixel(25 + x, 17 + y, 229, 223, 87);
        gfx.PutPixel(26 + x, 17 + y, 214, 214, 30);
        gfx.PutPixel(27 + x, 17 + y, 194, 194, 23);
        gfx.PutPixel(28 + x, 17 + y, 181, 181, 27);
        gfx.PutPixel(6 + x, 18 + y, 214, 214, 58);
        gfx.PutPixel(7 + x, 18 + y, 158, 158, 0);
        gfx.PutPixel(8 + x, 18 + y, 183, 183, 0);
        gfx.PutPixel(9 + x, 18 + y, 246, 246, 0);
        gfx.PutPixel(10 + x, 18 + y, 253, 253, 1);
        gfx.PutPixel(11 + x, 18 + y, 249, 236, 51);
        gfx.PutPixel(12 + x, 18 + y, 250, 233, 76);
        gfx.PutPixel(13 + x, 18 + y, 252, 248, 48);
        gfx.PutPixel(14 + x, 18 + y, 247, 228, 109);
        gfx.PutPixel(15 + x, 18 + y, 248, 227, 118);
        gfx.PutPixel(16 + x, 18 + y, 253, 243, 59);
        gfx.PutPixel(17 + x, 18 + y, 255, 255, 48);
        gfx.PutPixel(18 + x, 18 + y, 252, 250, 97);
        gfx.PutPixel(19 + x, 18 + y, 250, 250, 25);
        gfx.PutPixel(20 + x, 18 + y, 233, 233, 0);
        gfx.PutPixel(21 + x, 18 + y, 244, 244, 0);
        gfx.PutPixel(22 + x, 18 + y, 247, 247, 0);
        gfx.PutPixel(23 + x, 18 + y, 226, 226, 3);
        gfx.PutPixel(24 + x, 18 + y, 232, 228, 32);
        gfx.PutPixel(25 + x, 18 + y, 218, 217, 12);
        gfx.PutPixel(26 + x, 18 + y, 174, 175, 10);
        gfx.PutPixel(27 + x, 18 + y, 207, 207, 144);
        gfx.PutPixel(6 + x, 19 + y, 214, 214, 58);
        gfx.PutPixel(7 + x, 19 + y, 176, 176, 0);
        gfx.PutPixel(8 + x, 19 + y, 222, 222, 0);
        gfx.PutPixel(9 + x, 19 + y, 254, 254, 0);
        gfx.PutPixel(10 + x, 19 + y, 255, 255, 67);
        gfx.PutPixel(11 + x, 19 + y, 255, 250, 63);
        gfx.PutPixel(12 + x, 19 + y, 249, 243, 42);
        gfx.PutPixel(13 + x, 19 + y, 242, 240, 67);
        gfx.PutPixel(14 + x, 19 + y, 255, 248, 29);
        gfx.PutPixel(15 + x, 19 + y, 255, 248, 24);
        gfx.PutPixel(16 + x, 19 + y, 242, 239, 4);
        gfx.PutPixel(17 + x, 19 + y, 237, 231, 34);
        gfx.PutPixel(18 + x, 19 + y, 246, 233, 85);
        gfx.PutPixel(19 + x, 19 + y, 232, 231, 3);
        gfx.PutPixel(20 + x, 19 + y, 242, 244, 0);
        gfx.PutPixel(21 + x, 19 + y, 240, 241, 0);
        gfx.PutPixel(22 + x, 19 + y, 201, 201, 0);
        gfx.PutPixel(23 + x, 19 + y, 181, 181, 27);
        gfx.PutPixel(24 + x, 19 + y, 181, 181, 27);
        gfx.PutPixel(25 + x, 19 + y, 179, 179, 69);
        gfx.PutPixel(26 + x, 19 + y, 218, 217, 12);
        gfx.PutPixel(27 + x, 19 + y, 166, 166, 18);
        gfx.PutPixel(5 + x, 20 + y, 214, 214, 58);
        gfx.PutPixel(6 + x, 20 + y, 232, 232, 128);
        gfx.PutPixel(7 + x, 20 + y, 206, 206, 0);
        gfx.PutPixel(8 + x, 20 + y, 240, 240, 9);
        gfx.PutPixel(9 + x, 20 + y, 254, 254, 65);
        gfx.PutPixel(10 + x, 20 + y, 255, 255, 65);
        gfx.PutPixel(11 + x, 20 + y, 255, 255, 23);
        gfx.PutPixel(12 + x, 20 + y, 229, 230, 10);
        gfx.PutPixel(13 + x, 20 + y, 182, 182, 38);
        gfx.PutPixel(14 + x, 20 + y, 216, 216, 0);
        gfx.PutPixel(15 + x, 20 + y, 219, 220, 0);
        gfx.PutPixel(16 + x, 20 + y, 232, 233, 0);
        gfx.PutPixel(17 + x, 20 + y, 239, 236, 14);
        gfx.PutPixel(18 + x, 20 + y, 234, 226, 31);
        gfx.PutPixel(19 + x, 20 + y, 238, 238, 0);
        gfx.PutPixel(20 + x, 20 + y, 250, 238, 42);
        gfx.PutPixel(21 + x, 20 + y, 239, 232, 24);
        gfx.PutPixel(22 + x, 20 + y, 170, 171, 0);
        gfx.PutPixel(23 + x, 20 + y, 204, 204, 136);
        gfx.PutPixel(5 + x, 21 + y, 214, 214, 58);
        gfx.PutPixel(6 + x, 21 + y, 154, 154, 0);
        gfx.PutPixel(7 + x, 21 + y, 213, 213, 0);
        gfx.PutPixel(8 + x, 21 + y, 224, 224, 10);
        gfx.PutPixel(9 + x, 21 + y, 230, 230, 76);
        gfx.PutPixel(10 + x, 21 + y, 231, 231, 10);
        gfx.PutPixel(11 + x, 21 + y, 253, 253, 64);
        gfx.PutPixel(12 + x, 21 + y, 235, 235, 129);
        gfx.PutPixel(13 + x, 21 + y, 197, 197, 122);
        gfx.PutPixel(14 + x, 21 + y, 221, 221, 135);
        gfx.PutPixel(15 + x, 21 + y, 189, 189, 38);
        gfx.PutPixel(16 + x, 21 + y, 205, 205, 0);
        gfx.PutPixel(17 + x, 21 + y, 246, 247, 0);
        gfx.PutPixel(18 + x, 21 + y, 238, 239, 0);
        gfx.PutPixel(19 + x, 21 + y, 255, 255, 0);
        gfx.PutPixel(20 + x, 21 + y, 252, 237, 54);
        gfx.PutPixel(21 + x, 21 + y, 229, 221, 26);
        gfx.PutPixel(22 + x, 21 + y, 193, 194, 44);
        gfx.PutPixel(23 + x, 21 + y, 166, 166, 18);
        gfx.PutPixel(5 + x, 22 + y, 214, 214, 58);
        gfx.PutPixel(6 + x, 22 + y, 168, 168, 44);
        gfx.PutPixel(7 + x, 22 + y, 163, 163, 0);
        gfx.PutPixel(8 + x, 22 + y, 199, 199, 5);
        gfx.PutPixel(9 + x, 22 + y, 225, 225, 108);
        gfx.PutPixel(10 + x, 22 + y, 228, 228, 126);
        gfx.PutPixel(11 + x, 22 + y, 251, 251, 68);
        gfx.PutPixel(15 + x, 22 + y, 181, 181, 27);
        gfx.PutPixel(16 + x, 22 + y, 204, 204, 39);
        gfx.PutPixel(17 + x, 22 + y, 236, 236, 0);
        gfx.PutPixel(18 + x, 22 + y, 252, 252, 0);
        gfx.PutPixel(19 + x, 22 + y, 255, 255, 0);
        gfx.PutPixel(20 + x, 22 + y, 254, 253, 3);
        gfx.PutPixel(21 + x, 22 + y, 213, 212, 0);
        gfx.PutPixel(22 + x, 22 + y, 196, 197, 0);
        gfx.PutPixel(6 + x, 23 + y, 214, 214, 58);
        gfx.PutPixel(7 + x, 23 + y, 148, 148, 25);
        gfx.PutPixel(8 + x, 23 + y, 203, 203, 104);
        gfx.PutPixel(9 + x, 23 + y, 214, 214, 58);
        gfx.PutPixel(16 + x, 23 + y, 181, 181, 27);
        gfx.PutPixel(17 + x, 23 + y, 230, 230, 0);
        gfx.PutPixel(18 + x, 23 + y, 253, 253, 0);
        gfx.PutPixel(19 + x, 23 + y, 255, 255, 4);
        gfx.PutPixel(20 + x, 23 + y, 253, 253, 0);
        gfx.PutPixel(21 + x, 23 + y, 196, 197, 0);
        gfx.PutPixel(22 + x, 23 + y, 208, 208, 137);
        gfx.PutPixel(6 + x, 24 + y, 214, 214, 58);
        gfx.PutPixel(7 + x, 24 + y, 214, 214, 58);
        gfx.PutPixel(8 + x, 24 + y, 214, 214, 58);
        gfx.PutPixel(16 + x, 24 + y, 181, 181, 27);
        gfx.PutPixel(17 + x, 24 + y, 217, 217, 0);
        gfx.PutPixel(18 + x, 24 + y, 250, 250, 16);
        gfx.PutPixel(19 + x, 24 + y, 235, 235, 92);
        gfx.PutPixel(20 + x, 24 + y, 234, 234, 17);
        gfx.PutPixel(21 + x, 24 + y, 163, 163, 0);
        gfx.PutPixel(22 + x, 24 + y, 188, 188, 122);
        gfx.PutPixel(17 + x, 25 + y, 172, 172, 0);
        gfx.PutPixel(18 + x, 25 + y, 229, 229, 8);
        gfx.PutPixel(19 + x, 25 + y, 227, 227, 48);
        gfx.PutPixel(20 + x, 25 + y, 179, 179, 14);
        gfx.PutPixel(21 + x, 25 + y, 234, 234, 17);
        gfx.PutPixel(17 + x, 26 + y, 137, 137, 0);
        gfx.PutPixel(18 + x, 26 + y, 200, 200, 21);
        gfx.PutPixel(19 + x, 26 + y, 230, 230, 0);
        gfx.PutPixel(20 + x, 26 + y, 155, 155, 11);
        gfx.PutPixel(21 + x, 26 + y, 148, 148, 71);
        gfx.PutPixel(17 + x, 27 + y, 122, 122, 0);
        gfx.PutPixel(18 + x, 27 + y, 161, 161, 46);
        gfx.PutPixel(19 + x, 27 + y, 201, 201, 9);
        gfx.PutPixel(20 + x, 27 + y, 142, 142, 8);
        gfx.PutPixel(21 + x, 27 + y, 148, 148, 71);
        gfx.PutPixel(17 + x, 28 + y, 135, 135, 15);
        gfx.PutPixel(18 + x, 28 + y, 130, 130, 19);
        gfx.PutPixel(19 + x, 28 + y, 163, 163, 88);
        gfx.PutPixel(20 + x, 28 + y, 148, 148, 71);
        gfx.PutPixel(21 + x, 28 + y, 148, 148, 71);
        gfx.PutPixel(18 + x, 29 + y, 186, 186, 125);
        gfx.PutPixel(19 + x, 29 + y, 148, 148, 71);
        gfx.PutPixel(20 + x, 29 + y, 148, 148, 71);
    }

    if (animation_status >= 30 && animation_status < 40)
    {
        gfx.PutPixel(21 + x, 1 + y, 251, 251, 68);
        gfx.PutPixel(22 + x, 1 + y, 169, 169, 70);
        gfx.PutPixel(23 + x, 1 + y, 166, 166, 18);
        gfx.PutPixel(20 + x, 2 + y, 251, 251, 68);
        gfx.PutPixel(21 + x, 2 + y, 149, 149, 5);
        gfx.PutPixel(22 + x, 2 + y, 157, 157, 15);
        gfx.PutPixel(23 + x, 2 + y, 128, 128, 0);
        gfx.PutPixel(24 + x, 2 + y, 166, 166, 18);
        gfx.PutPixel(19 + x, 3 + y, 251, 251, 68);
        gfx.PutPixel(20 + x, 3 + y, 159, 159, 14);
        gfx.PutPixel(21 + x, 3 + y, 186, 186, 7);
        gfx.PutPixel(22 + x, 3 + y, 185, 185, 57);
        gfx.PutPixel(23 + x, 3 + y, 126, 126, 0);
        gfx.PutPixel(24 + x, 3 + y, 166, 166, 18);
        gfx.PutPixel(25 + x, 3 + y, 166, 166, 18);
        gfx.PutPixel(19 + x, 4 + y, 251, 251, 68);
        gfx.PutPixel(20 + x, 4 + y, 131, 131, 0);
        gfx.PutPixel(21 + x, 4 + y, 201, 201, 2);
        gfx.PutPixel(22 + x, 4 + y, 207, 207, 12);
        gfx.PutPixel(23 + x, 4 + y, 141, 141, 0);
        gfx.PutPixel(24 + x, 4 + y, 120, 120, 29);
        gfx.PutPixel(25 + x, 4 + y, 166, 166, 18);
        gfx.PutPixel(7 + x, 5 + y, 214, 214, 58);
        gfx.PutPixel(8 + x, 5 + y, 214, 214, 58);
        gfx.PutPixel(9 + x, 5 + y, 214, 214, 58);
        gfx.PutPixel(14 + x, 5 + y, 251, 251, 68);
        gfx.PutPixel(15 + x, 5 + y, 251, 251, 68);
        gfx.PutPixel(17 + x, 5 + y, 251, 251, 68);
        gfx.PutPixel(18 + x, 5 + y, 251, 251, 68);
        gfx.PutPixel(19 + x, 5 + y, 251, 251, 68);
        gfx.PutPixel(20 + x, 5 + y, 153, 153, 0);
        gfx.PutPixel(21 + x, 5 + y, 195, 195, 0);
        gfx.PutPixel(22 + x, 5 + y, 198, 198, 0);
        gfx.PutPixel(23 + x, 5 + y, 181, 181, 0);
        gfx.PutPixel(24 + x, 5 + y, 131, 131, 0);
        gfx.PutPixel(25 + x, 5 + y, 146, 146, 76);
        gfx.PutPixel(26 + x, 5 + y, 166, 166, 18);
        gfx.PutPixel(5 + x, 6 + y, 214, 214, 58);
        gfx.PutPixel(6 + x, 6 + y, 214, 214, 58);
        gfx.PutPixel(7 + x, 6 + y, 168, 168, 44);
        gfx.PutPixel(8 + x, 6 + y, 154, 154, 0);
        gfx.PutPixel(9 + x, 6 + y, 232, 232, 128);
        gfx.PutPixel(10 + x, 6 + y, 214, 214, 58);
        gfx.PutPixel(11 + x, 6 + y, 214, 214, 58);
        gfx.PutPixel(12 + x, 6 + y, 214, 214, 58);
        gfx.PutPixel(13 + x, 6 + y, 214, 214, 58);
        gfx.PutPixel(14 + x, 6 + y, 235, 235, 134);
        gfx.PutPixel(15 + x, 6 + y, 214, 214, 58);
        gfx.PutPixel(16 + x, 6 + y, 251, 251, 68);
        gfx.PutPixel(17 + x, 6 + y, 235, 235, 62);
        gfx.PutPixel(18 + x, 6 + y, 232, 232, 35);
        gfx.PutPixel(19 + x, 6 + y, 236, 236, 109);
        gfx.PutPixel(20 + x, 6 + y, 196, 196, 0);
        gfx.PutPixel(21 + x, 6 + y, 223, 223, 0);
        gfx.PutPixel(22 + x, 6 + y, 218, 218, 0);
        gfx.PutPixel(23 + x, 6 + y, 200, 200, 0);
        gfx.PutPixel(24 + x, 6 + y, 165, 165, 0);
        gfx.PutPixel(25 + x, 6 + y, 122, 122, 0);
        gfx.PutPixel(26 + x, 6 + y, 139, 139, 54);
        gfx.PutPixel(27 + x, 6 + y, 181, 181, 27);
        gfx.PutPixel(5 + x, 7 + y, 214, 214, 58);
        gfx.PutPixel(6 + x, 7 + y, 148, 148, 25);
        gfx.PutPixel(7 + x, 7 + y, 163, 163, 0);
        gfx.PutPixel(8 + x, 7 + y, 213, 213, 0);
        gfx.PutPixel(9 + x, 7 + y, 206, 206, 0);
        gfx.PutPixel(10 + x, 7 + y, 176, 176, 0);
        gfx.PutPixel(11 + x, 7 + y, 158, 158, 0);
        gfx.PutPixel(12 + x, 7 + y, 163, 163, 3);
        gfx.PutPixel(13 + x, 7 + y, 176, 176, 43);
        gfx.PutPixel(14 + x, 7 + y, 219, 220, 46);
        gfx.PutPixel(15 + x, 7 + y, 229, 230, 15);
        gfx.PutPixel(16 + x, 7 + y, 196, 196, 34);
        gfx.PutPixel(17 + x, 7 + y, 245, 245, 113);
        gfx.PutPixel(18 + x, 7 + y, 240, 240, 54);
        gfx.PutPixel(19 + x, 7 + y, 230, 230, 0);
        gfx.PutPixel(20 + x, 7 + y, 241, 241, 0);
        gfx.PutPixel(21 + x, 7 + y, 255, 255, 0);
        gfx.PutPixel(22 + x, 7 + y, 251, 251, 0);
        gfx.PutPixel(23 + x, 7 + y, 221, 221, 0);
        gfx.PutPixel(24 + x, 7 + y, 191, 191, 0);
        gfx.PutPixel(25 + x, 7 + y, 167, 167, 0);
        gfx.PutPixel(26 + x, 7 + y, 166, 166, 18);
        gfx.PutPixel(27 + x, 7 + y, 166, 166, 18);
        gfx.PutPixel(5 + x, 8 + y, 214, 214, 58);
        gfx.PutPixel(6 + x, 8 + y, 203, 203, 104);
        gfx.PutPixel(7 + x, 8 + y, 199, 199, 5);
        gfx.PutPixel(8 + x, 8 + y, 224, 224, 10);
        gfx.PutPixel(9 + x, 8 + y, 240, 240, 9);
        gfx.PutPixel(10 + x, 8 + y, 222, 222, 0);
        gfx.PutPixel(11 + x, 8 + y, 183, 183, 0);
        gfx.PutPixel(12 + x, 8 + y, 230, 230, 0);
        gfx.PutPixel(13 + x, 8 + y, 246, 247, 0);
        gfx.PutPixel(14 + x, 8 + y, 252, 250, 61);
        gfx.PutPixel(15 + x, 8 + y, 243, 240, 78);
        gfx.PutPixel(16 + x, 8 + y, 228, 228, 5);
        gfx.PutPixel(17 + x, 8 + y, 250, 250, 37);
        gfx.PutPixel(18 + x, 8 + y, 249, 249, 22);
        gfx.PutPixel(19 + x, 8 + y, 250, 250, 5);
        gfx.PutPixel(20 + x, 8 + y, 253, 253, 0);
        gfx.PutPixel(21 + x, 8 + y, 252, 252, 0);
        gfx.PutPixel(22 + x, 8 + y, 254, 254, 0);
        gfx.PutPixel(23 + x, 8 + y, 252, 252, 0);
        gfx.PutPixel(24 + x, 8 + y, 238, 238, 0);
        gfx.PutPixel(25 + x, 8 + y, 188, 188, 0);
        gfx.PutPixel(26 + x, 8 + y, 186, 186, 78);
        gfx.PutPixel(6 + x, 9 + y, 214, 214, 58);
        gfx.PutPixel(7 + x, 9 + y, 225, 225, 108);
        gfx.PutPixel(8 + x, 9 + y, 230, 230, 76);
        gfx.PutPixel(9 + x, 9 + y, 254, 254, 65);
        gfx.PutPixel(10 + x, 9 + y, 254, 254, 0);
        gfx.PutPixel(11 + x, 9 + y, 246, 246, 0);
        gfx.PutPixel(12 + x, 9 + y, 255, 255, 0);
        gfx.PutPixel(13 + x, 9 + y, 255, 255, 0);
        gfx.PutPixel(14 + x, 9 + y, 254, 242, 52);
        gfx.PutPixel(15 + x, 9 + y, 250, 235, 71);
        gfx.PutPixel(16 + x, 9 + y, 253, 254, 0);
        gfx.PutPixel(17 + x, 9 + y, 252, 252, 0);
        gfx.PutPixel(18 + x, 9 + y, 230, 230, 79);
        gfx.PutPixel(19 + x, 9 + y, 241, 241, 54);
        gfx.PutPixel(20 + x, 9 + y, 245, 245, 0);
        gfx.PutPixel(21 + x, 9 + y, 228, 228, 0);
        gfx.PutPixel(22 + x, 9 + y, 252, 252, 0);
        gfx.PutPixel(23 + x, 9 + y, 255, 255, 0);
        gfx.PutPixel(24 + x, 9 + y, 255, 255, 0);
        gfx.PutPixel(25 + x, 9 + y, 195, 195, 0);
        gfx.PutPixel(26 + x, 9 + y, 120, 120, 2);
        gfx.PutPixel(27 + x, 9 + y, 211, 211, 120);
        gfx.PutPixel(7 + x, 10 + y, 228, 228, 126);
        gfx.PutPixel(8 + x, 10 + y, 231, 231, 10);
        gfx.PutPixel(9 + x, 10 + y, 255, 255, 65);
        gfx.PutPixel(10 + x, 10 + y, 255, 255, 67);
        gfx.PutPixel(11 + x, 10 + y, 253, 253, 1);
        gfx.PutPixel(12 + x, 10 + y, 236, 236, 0);
        gfx.PutPixel(13 + x, 10 + y, 231, 232, 0);
        gfx.PutPixel(14 + x, 10 + y, 239, 227, 46);
        gfx.PutPixel(15 + x, 10 + y, 249, 225, 89);
        gfx.PutPixel(16 + x, 10 + y, 250, 237, 89);
        gfx.PutPixel(17 + x, 10 + y, 253, 250, 153);
        gfx.PutPixel(18 + x, 10 + y, 247, 248, 74);
        gfx.PutPixel(19 + x, 10 + y, 250, 250, 11);
        gfx.PutPixel(20 + x, 10 + y, 252, 252, 0);
        gfx.PutPixel(21 + x, 10 + y, 243, 243, 0);
        gfx.PutPixel(22 + x, 10 + y, 234, 234, 8);
        gfx.PutPixel(23 + x, 10 + y, 230, 231, 69);
        gfx.PutPixel(24 + x, 10 + y, 247, 246, 37);
        gfx.PutPixel(25 + x, 10 + y, 242, 242, 0);
        gfx.PutPixel(26 + x, 10 + y, 199, 199, 0);
        gfx.PutPixel(27 + x, 10 + y, 205, 205, 74);
        gfx.PutPixel(7 + x, 11 + y, 251, 251, 68);
        gfx.PutPixel(8 + x, 11 + y, 253, 253, 64);
        gfx.PutPixel(9 + x, 11 + y, 255, 255, 23);
        gfx.PutPixel(10 + x, 11 + y, 255, 250, 63);
        gfx.PutPixel(11 + x, 11 + y, 249, 236, 51);
        gfx.PutPixel(12 + x, 11 + y, 237, 224, 46);
        gfx.PutPixel(13 + x, 11 + y, 233, 220, 47);
        gfx.PutPixel(14 + x, 11 + y, 242, 230, 38);
        gfx.PutPixel(15 + x, 11 + y, 252, 240, 71);
        gfx.PutPixel(16 + x, 11 + y, 252, 241, 169);
        gfx.PutPixel(17 + x, 11 + y, 254, 252, 229);
        gfx.PutPixel(18 + x, 11 + y, 255, 255, 109);
        gfx.PutPixel(19 + x, 11 + y, 255, 255, 61);
        gfx.PutPixel(20 + x, 11 + y, 255, 255, 37);
        gfx.PutPixel(21 + x, 11 + y, 253, 253, 0);
        gfx.PutPixel(22 + x, 11 + y, 240, 239, 10);
        gfx.PutPixel(23 + x, 11 + y, 234, 223, 96);
        gfx.PutPixel(24 + x, 11 + y, 236, 231, 50);
        gfx.PutPixel(25 + x, 11 + y, 241, 242, 0);
        gfx.PutPixel(26 + x, 11 + y, 229, 229, 0);
        gfx.PutPixel(27 + x, 11 + y, 227, 227, 82);
        gfx.PutPixel(28 + x, 11 + y, 251, 251, 68);
        gfx.PutPixel(8 + x, 12 + y, 235, 235, 129);
        gfx.PutPixel(9 + x, 12 + y, 229, 230, 10);
        gfx.PutPixel(10 + x, 12 + y, 249, 243, 42);
        gfx.PutPixel(11 + x, 12 + y, 250, 233, 76);
        gfx.PutPixel(12 + x, 12 + y, 250, 233, 115);
        gfx.PutPixel(13 + x, 12 + y, 249, 224, 108);
        gfx.PutPixel(14 + x, 12 + y, 252, 239, 79);
        gfx.PutPixel(15 + x, 12 + y, 255, 255, 120);
        gfx.PutPixel(16 + x, 12 + y, 255, 255, 222);
        gfx.PutPixel(17 + x, 12 + y, 255, 255, 243);
        gfx.PutPixel(18 + x, 12 + y, 255, 255, 196);
        gfx.PutPixel(19 + x, 12 + y, 254, 249, 147);
        gfx.PutPixel(20 + x, 12 + y, 253, 248, 89);
        gfx.PutPixel(21 + x, 12 + y, 254, 255, 31);
        gfx.PutPixel(22 + x, 12 + y, 255, 254, 9);
        gfx.PutPixel(23 + x, 12 + y, 253, 239, 53);
        gfx.PutPixel(24 + x, 12 + y, 239, 226, 45);
        gfx.PutPixel(25 + x, 12 + y, 230, 226, 32);
        gfx.PutPixel(26 + x, 12 + y, 233, 233, 27);
        gfx.PutPixel(27 + x, 12 + y, 243, 243, 57);
        gfx.PutPixel(28 + x, 12 + y, 251, 251, 68);
        gfx.PutPixel(8 + x, 13 + y, 197, 197, 122);
        gfx.PutPixel(9 + x, 13 + y, 182, 182, 38);
        gfx.PutPixel(10 + x, 13 + y, 242, 240, 67);
        gfx.PutPixel(11 + x, 13 + y, 252, 248, 48);
        gfx.PutPixel(12 + x, 13 + y, 251, 249, 157);
        gfx.PutPixel(13 + x, 13 + y, 249, 232, 128);
        gfx.PutPixel(14 + x, 13 + y, 252, 241, 155);
        gfx.PutPixel(15 + x, 13 + y, 255, 255, 235);
        gfx.PutPixel(16 + x, 13 + y, 255, 255, 254);
        gfx.PutPixel(17 + x, 13 + y, 255, 255, 253);
        gfx.PutPixel(18 + x, 13 + y, 254, 255, 243);
        gfx.PutPixel(19 + x, 13 + y, 251, 241, 161);
        gfx.PutPixel(20 + x, 13 + y, 249, 237, 120);
        gfx.PutPixel(21 + x, 13 + y, 250, 250, 134);
        gfx.PutPixel(22 + x, 13 + y, 253, 250, 34);
        gfx.PutPixel(23 + x, 13 + y, 255, 253, 16);
        gfx.PutPixel(24 + x, 13 + y, 249, 236, 60);
        gfx.PutPixel(25 + x, 13 + y, 246, 232, 99);
        gfx.PutPixel(26 + x, 13 + y, 248, 250, 80);
        gfx.PutPixel(27 + x, 13 + y, 245, 245, 13);
        gfx.PutPixel(28 + x, 13 + y, 233, 233, 23);
        gfx.PutPixel(29 + x, 13 + y, 251, 251, 68);
        gfx.PutPixel(8 + x, 14 + y, 221, 221, 135);
        gfx.PutPixel(9 + x, 14 + y, 216, 216, 0);
        gfx.PutPixel(10 + x, 14 + y, 255, 248, 29);
        gfx.PutPixel(11 + x, 14 + y, 247, 228, 109);
        gfx.PutPixel(12 + x, 14 + y, 242, 238, 205);
        gfx.PutPixel(13 + x, 14 + y, 247, 246, 173);
        gfx.PutPixel(14 + x, 14 + y, 253, 253, 128);
        gfx.PutPixel(15 + x, 14 + y, 255, 255, 172);
        gfx.PutPixel(16 + x, 14 + y, 255, 255, 255);
        gfx.PutPixel(17 + x, 14 + y, 254, 254, 246);
        gfx.PutPixel(18 + x, 14 + y, 251, 252, 180);
        gfx.PutPixel(19 + x, 14 + y, 254, 251, 125);
        gfx.PutPixel(20 + x, 14 + y, 249, 247, 165);
        gfx.PutPixel(21 + x, 14 + y, 240, 236, 220);
        gfx.PutPixel(22 + x, 14 + y, 247, 229, 109);
        gfx.PutPixel(23 + x, 14 + y, 255, 251, 102);
        gfx.PutPixel(24 + x, 14 + y, 252, 239, 107);
        gfx.PutPixel(25 + x, 14 + y, 236, 221, 61);
        gfx.PutPixel(26 + x, 14 + y, 222, 224, 1);
        gfx.PutPixel(27 + x, 14 + y, 223, 223, 0);
        gfx.PutPixel(28 + x, 14 + y, 222, 222, 0);
        gfx.PutPixel(29 + x, 14 + y, 207, 207, 20);
        gfx.PutPixel(7 + x, 15 + y, 181, 181, 27);
        gfx.PutPixel(8 + x, 15 + y, 189, 189, 38);
        gfx.PutPixel(9 + x, 15 + y, 219, 220, 0);
        gfx.PutPixel(10 + x, 15 + y, 255, 248, 24);
        gfx.PutPixel(11 + x, 15 + y, 248, 227, 118);
        gfx.PutPixel(12 + x, 15 + y, 250, 246, 226);
        gfx.PutPixel(13 + x, 15 + y, 253, 254, 241);
        gfx.PutPixel(14 + x, 15 + y, 255, 255, 224);
        gfx.PutPixel(15 + x, 15 + y, 255, 255, 232);
        gfx.PutPixel(16 + x, 15 + y, 255, 255, 255);
        gfx.PutPixel(17 + x, 15 + y, 255, 255, 253);
        gfx.PutPixel(18 + x, 15 + y, 254, 254, 235);
        gfx.PutPixel(19 + x, 15 + y, 255, 255, 228);
        gfx.PutPixel(20 + x, 15 + y, 252, 253, 207);
        gfx.PutPixel(21 + x, 15 + y, 249, 248, 167);
        gfx.PutPixel(22 + x, 15 + y, 249, 244, 152);
        gfx.PutPixel(23 + x, 15 + y, 244, 245, 207);
        gfx.PutPixel(24 + x, 15 + y, 245, 231, 156);
        gfx.PutPixel(25 + x, 15 + y, 248, 233, 46);
        gfx.PutPixel(26 + x, 15 + y, 247, 248, 9);
        gfx.PutPixel(27 + x, 15 + y, 244, 244, 84);
        gfx.PutPixel(28 + x, 15 + y, 229, 229, 93);
        gfx.PutPixel(29 + x, 15 + y, 217, 217, 26);
        gfx.PutPixel(5 + x, 16 + y, 181, 181, 27);
        gfx.PutPixel(6 + x, 16 + y, 181, 181, 27);
        gfx.PutPixel(7 + x, 16 + y, 204, 204, 39);
        gfx.PutPixel(8 + x, 16 + y, 205, 205, 0);
        gfx.PutPixel(9 + x, 16 + y, 232, 233, 0);
        gfx.PutPixel(10 + x, 16 + y, 242, 239, 4);
        gfx.PutPixel(11 + x, 16 + y, 253, 243, 59);
        gfx.PutPixel(12 + x, 16 + y, 254, 252, 160);
        gfx.PutPixel(13 + x, 16 + y, 252, 242, 175);
        gfx.PutPixel(14 + x, 16 + y, 251, 244, 180);
        gfx.PutPixel(15 + x, 16 + y, 254, 255, 221);
        gfx.PutPixel(16 + x, 16 + y, 255, 255, 255);
        gfx.PutPixel(17 + x, 16 + y, 255, 255, 255);
        gfx.PutPixel(18 + x, 16 + y, 255, 255, 255);
        gfx.PutPixel(19 + x, 16 + y, 255, 255, 255);
        gfx.PutPixel(20 + x, 16 + y, 253, 253, 219);
        gfx.PutPixel(21 + x, 16 + y, 252, 252, 146);
        gfx.PutPixel(22 + x, 16 + y, 251, 252, 160);
        gfx.PutPixel(23 + x, 16 + y, 247, 248, 203);
        gfx.PutPixel(24 + x, 16 + y, 249, 243, 117);
        gfx.PutPixel(25 + x, 16 + y, 255, 248, 14);
        gfx.PutPixel(26 + x, 16 + y, 255, 255, 8);
        gfx.PutPixel(27 + x, 16 + y, 255, 255, 53);
        gfx.PutPixel(28 + x, 16 + y, 248, 248, 59);
        gfx.PutPixel(29 + x, 16 + y, 229, 229, 7);
        gfx.PutPixel(1 + x, 17 + y, 135, 135, 15);
        gfx.PutPixel(2 + x, 17 + y, 122, 122, 0);
        gfx.PutPixel(3 + x, 17 + y, 137, 137, 0);
        gfx.PutPixel(4 + x, 17 + y, 172, 172, 0);
        gfx.PutPixel(5 + x, 17 + y, 217, 217, 0);
        gfx.PutPixel(6 + x, 17 + y, 230, 230, 0);
        gfx.PutPixel(7 + x, 17 + y, 236, 236, 0);
        gfx.PutPixel(8 + x, 17 + y, 246, 247, 0);
        gfx.PutPixel(9 + x, 17 + y, 239, 236, 14);
        gfx.PutPixel(10 + x, 17 + y, 237, 231, 34);
        gfx.PutPixel(11 + x, 17 + y, 255, 255, 48);
        gfx.PutPixel(12 + x, 17 + y, 253, 247, 97);
        gfx.PutPixel(13 + x, 17 + y, 250, 235, 100);
        gfx.PutPixel(14 + x, 17 + y, 251, 241, 139);
        gfx.PutPixel(15 + x, 17 + y, 254, 255, 199);
        gfx.PutPixel(16 + x, 17 + y, 254, 254, 220);
        gfx.PutPixel(17 + x, 17 + y, 251, 251, 246);
        gfx.PutPixel(18 + x, 17 + y, 254, 254, 255);
        gfx.PutPixel(19 + x, 17 + y, 255, 255, 250);
        gfx.PutPixel(20 + x, 17 + y, 253, 253, 203);
        gfx.PutPixel(21 + x, 17 + y, 251, 249, 147);
        gfx.PutPixel(22 + x, 17 + y, 251, 244, 135);
        gfx.PutPixel(23 + x, 17 + y, 253, 251, 115);
        gfx.PutPixel(24 + x, 17 + y, 249, 250, 35);
        gfx.PutPixel(25 + x, 17 + y, 245, 246, 0);
        gfx.PutPixel(26 + x, 17 + y, 240, 240, 0);
        gfx.PutPixel(27 + x, 17 + y, 222, 222, 0);
        gfx.PutPixel(28 + x, 17 + y, 218, 218, 0);
        gfx.PutPixel(29 + x, 17 + y, 243, 243, 103);
        gfx.PutPixel(0 + x, 18 + y, 186, 186, 125);
        gfx.PutPixel(1 + x, 18 + y, 130, 130, 19);
        gfx.PutPixel(2 + x, 18 + y, 161, 161, 46);
        gfx.PutPixel(3 + x, 18 + y, 200, 200, 21);
        gfx.PutPixel(4 + x, 18 + y, 229, 229, 8);
        gfx.PutPixel(5 + x, 18 + y, 250, 250, 16);
        gfx.PutPixel(6 + x, 18 + y, 253, 253, 0);
        gfx.PutPixel(7 + x, 18 + y, 252, 252, 0);
        gfx.PutPixel(8 + x, 18 + y, 238, 239, 0);
        gfx.PutPixel(9 + x, 18 + y, 234, 226, 31);
        gfx.PutPixel(10 + x, 18 + y, 246, 233, 85);
        gfx.PutPixel(11 + x, 18 + y, 252, 250, 97);
        gfx.PutPixel(12 + x, 18 + y, 246, 232, 101);
        gfx.PutPixel(13 + x, 18 + y, 251, 244, 96);
        gfx.PutPixel(14 + x, 18 + y, 254, 251, 163);
        gfx.PutPixel(15 + x, 18 + y, 253, 250, 197);
        gfx.PutPixel(16 + x, 18 + y, 252, 252, 155);
        gfx.PutPixel(17 + x, 18 + y, 246, 246, 226);
        gfx.PutPixel(18 + x, 18 + y, 251, 251, 239);
        gfx.PutPixel(19 + x, 18 + y, 255, 255, 214);
        gfx.PutPixel(20 + x, 18 + y, 253, 254, 183);
        gfx.PutPixel(21 + x, 18 + y, 252, 248, 146);
        gfx.PutPixel(22 + x, 18 + y, 250, 236, 84);
        gfx.PutPixel(23 + x, 18 + y, 255, 251, 16);
        gfx.PutPixel(24 + x, 18 + y, 246, 246, 57);
        gfx.PutPixel(25 + x, 18 + y, 232, 232, 36);
        gfx.PutPixel(26 + x, 18 + y, 234, 234, 57);
        gfx.PutPixel(27 + x, 18 + y, 230, 230, 121);
        gfx.PutPixel(28 + x, 18 + y, 222, 222, 106);
        gfx.PutPixel(29 + x, 18 + y, 251, 251, 68);
        gfx.PutPixel(0 + x, 19 + y, 148, 148, 71);
        gfx.PutPixel(1 + x, 19 + y, 163, 163, 88);
        gfx.PutPixel(2 + x, 19 + y, 201, 201, 9);
        gfx.PutPixel(3 + x, 19 + y, 230, 230, 0);
        gfx.PutPixel(4 + x, 19 + y, 227, 227, 48);
        gfx.PutPixel(5 + x, 19 + y, 235, 235, 92);
        gfx.PutPixel(6 + x, 19 + y, 255, 255, 4);
        gfx.PutPixel(7 + x, 19 + y, 255, 255, 0);
        gfx.PutPixel(8 + x, 19 + y, 255, 255, 0);
        gfx.PutPixel(9 + x, 19 + y, 238, 238, 0);
        gfx.PutPixel(10 + x, 19 + y, 232, 231, 3);
        gfx.PutPixel(11 + x, 19 + y, 250, 250, 25);
        gfx.PutPixel(12 + x, 19 + y, 231, 230, 89);
        gfx.PutPixel(13 + x, 19 + y, 245, 246, 28);
        gfx.PutPixel(14 + x, 19 + y, 252, 239, 48);
        gfx.PutPixel(15 + x, 19 + y, 249, 231, 128);
        gfx.PutPixel(16 + x, 19 + y, 252, 252, 170);
        gfx.PutPixel(17 + x, 19 + y, 253, 254, 231);
        gfx.PutPixel(18 + x, 19 + y, 255, 255, 168);
        gfx.PutPixel(19 + x, 19 + y, 255, 255, 167);
        gfx.PutPixel(20 + x, 19 + y, 255, 255, 203);
        gfx.PutPixel(21 + x, 19 + y, 255, 255, 165);
        gfx.PutPixel(22 + x, 19 + y, 255, 255, 28);
        gfx.PutPixel(23 + x, 19 + y, 255, 255, 0);
        gfx.PutPixel(24 + x, 19 + y, 244, 244, 124);
        gfx.PutPixel(25 + x, 19 + y, 233, 233, 61);
        gfx.PutPixel(26 + x, 19 + y, 251, 251, 68);
        gfx.PutPixel(28 + x, 19 + y, 251, 251, 68);
        gfx.PutPixel(0 + x, 20 + y, 148, 148, 71);
        gfx.PutPixel(1 + x, 20 + y, 148, 148, 71);
        gfx.PutPixel(2 + x, 20 + y, 142, 142, 8);
        gfx.PutPixel(3 + x, 20 + y, 155, 155, 11);
        gfx.PutPixel(4 + x, 20 + y, 179, 179, 14);
        gfx.PutPixel(5 + x, 20 + y, 234, 234, 17);
        gfx.PutPixel(6 + x, 20 + y, 253, 253, 0);
        gfx.PutPixel(7 + x, 20 + y, 254, 253, 3);
        gfx.PutPixel(8 + x, 20 + y, 252, 237, 54);
        gfx.PutPixel(9 + x, 20 + y, 250, 238, 42);
        gfx.PutPixel(10 + x, 20 + y, 242, 244, 0);
        gfx.PutPixel(11 + x, 20 + y, 233, 233, 0);
        gfx.PutPixel(12 + x, 20 + y, 245, 245, 25);
        gfx.PutPixel(13 + x, 20 + y, 253, 254, 82);
        gfx.PutPixel(14 + x, 20 + y, 254, 251, 56);
        gfx.PutPixel(15 + x, 20 + y, 253, 250, 50);
        gfx.PutPixel(16 + x, 20 + y, 254, 254, 156);
        gfx.PutPixel(17 + x, 20 + y, 255, 255, 218);
        gfx.PutPixel(18 + x, 20 + y, 255, 255, 75);
        gfx.PutPixel(19 + x, 20 + y, 254, 255, 91);
        gfx.PutPixel(20 + x, 20 + y, 250, 242, 154);
        gfx.PutPixel(21 + x, 20 + y, 250, 234, 97);
        gfx.PutPixel(22 + x, 20 + y, 249, 246, 14);
        gfx.PutPixel(23 + x, 20 + y, 212, 213, 0);
        gfx.PutPixel(24 + x, 20 + y, 233, 233, 90);
        gfx.PutPixel(25 + x, 20 + y, 237, 237, 84);
        gfx.PutPixel(1 + x, 21 + y, 148, 148, 71);
        gfx.PutPixel(2 + x, 21 + y, 148, 148, 71);
        gfx.PutPixel(3 + x, 21 + y, 148, 148, 71);
        gfx.PutPixel(4 + x, 21 + y, 234, 234, 17);
        gfx.PutPixel(5 + x, 21 + y, 163, 163, 0);
        gfx.PutPixel(6 + x, 21 + y, 196, 197, 0);
        gfx.PutPixel(7 + x, 21 + y, 213, 212, 0);
        gfx.PutPixel(8 + x, 21 + y, 229, 221, 26);
        gfx.PutPixel(9 + x, 21 + y, 239, 232, 24);
        gfx.PutPixel(10 + x, 21 + y, 240, 241, 0);
        gfx.PutPixel(11 + x, 21 + y, 244, 244, 0);
        gfx.PutPixel(12 + x, 21 + y, 253, 253, 1);
        gfx.PutPixel(13 + x, 21 + y, 255, 255, 39);
        gfx.PutPixel(14 + x, 21 + y, 245, 246, 63);
        gfx.PutPixel(15 + x, 21 + y, 241, 242, 56);
        gfx.PutPixel(16 + x, 21 + y, 255, 255, 75);
        gfx.PutPixel(17 + x, 21 + y, 253, 254, 160);
        gfx.PutPixel(18 + x, 21 + y, 254, 254, 44);
        gfx.PutPixel(19 + x, 21 + y, 255, 255, 22);
        gfx.PutPixel(20 + x, 21 + y, 252, 249, 93);
        gfx.PutPixel(21 + x, 21 + y, 251, 242, 110);
        gfx.PutPixel(22 + x, 21 + y, 252, 250, 16);
        gfx.PutPixel(23 + x, 21 + y, 232, 232, 0);
        gfx.PutPixel(24 + x, 21 + y, 242, 242, 145);
        gfx.PutPixel(25 + x, 21 + y, 239, 239, 107);
        gfx.PutPixel(5 + x, 22 + y, 188, 188, 122);
        gfx.PutPixel(6 + x, 22 + y, 208, 208, 137);
        gfx.PutPixel(7 + x, 22 + y, 196, 197, 0);
        gfx.PutPixel(8 + x, 22 + y, 193, 194, 44);
        gfx.PutPixel(9 + x, 22 + y, 170, 171, 0);
        gfx.PutPixel(10 + x, 22 + y, 201, 201, 0);
        gfx.PutPixel(11 + x, 22 + y, 247, 247, 0);
        gfx.PutPixel(12 + x, 22 + y, 254, 255, 0);
        gfx.PutPixel(13 + x, 22 + y, 248, 248, 0);
        gfx.PutPixel(14 + x, 22 + y, 237, 238, 36);
        gfx.PutPixel(15 + x, 22 + y, 239, 236, 64);
        gfx.PutPixel(16 + x, 22 + y, 253, 245, 38);
        gfx.PutPixel(17 + x, 22 + y, 253, 252, 76);
        gfx.PutPixel(18 + x, 22 + y, 255, 255, 24);
        gfx.PutPixel(19 + x, 22 + y, 248, 249, 0);
        gfx.PutPixel(20 + x, 22 + y, 246, 242, 50);
        gfx.PutPixel(21 + x, 22 + y, 253, 246, 121);
        gfx.PutPixel(22 + x, 22 + y, 251, 250, 16);
        gfx.PutPixel(23 + x, 22 + y, 222, 223, 0);
        gfx.PutPixel(24 + x, 22 + y, 243, 243, 160);
        gfx.PutPixel(25 + x, 22 + y, 239, 239, 110);
        gfx.PutPixel(8 + x, 23 + y, 166, 166, 18);
        gfx.PutPixel(9 + x, 23 + y, 204, 204, 136);
        gfx.PutPixel(10 + x, 23 + y, 181, 181, 27);
        gfx.PutPixel(11 + x, 23 + y, 226, 226, 3);
        gfx.PutPixel(12 + x, 23 + y, 247, 244, 14);
        gfx.PutPixel(13 + x, 23 + y, 232, 231, 5);
        gfx.PutPixel(14 + x, 23 + y, 239, 240, 0);
        gfx.PutPixel(15 + x, 23 + y, 252, 245, 36);
        gfx.PutPixel(16 + x, 23 + y, 249, 229, 79);
        gfx.PutPixel(17 + x, 23 + y, 253, 250, 20);
        gfx.PutPixel(18 + x, 23 + y, 255, 255, 0);
        gfx.PutPixel(19 + x, 23 + y, 243, 243, 11);
        gfx.PutPixel(20 + x, 23 + y, 234, 226, 51);
        gfx.PutPixel(21 + x, 23 + y, 246, 230, 65);
        gfx.PutPixel(22 + x, 23 + y, 245, 243, 19);
        gfx.PutPixel(23 + x, 23 + y, 230, 231, 89);
        gfx.PutPixel(24 + x, 23 + y, 251, 251, 68);
        gfx.PutPixel(25 + x, 23 + y, 251, 251, 68);
        gfx.PutPixel(10 + x, 24 + y, 181, 181, 27);
        gfx.PutPixel(11 + x, 24 + y, 232, 228, 32);
        gfx.PutPixel(12 + x, 24 + y, 243, 225, 65);
        gfx.PutPixel(13 + x, 24 + y, 229, 222, 25);
        gfx.PutPixel(14 + x, 24 + y, 237, 240, 0);
        gfx.PutPixel(15 + x, 24 + y, 254, 246, 32);
        gfx.PutPixel(16 + x, 24 + y, 248, 227, 83);
        gfx.PutPixel(17 + x, 24 + y, 253, 250, 13);
        gfx.PutPixel(18 + x, 24 + y, 255, 255, 0);
        gfx.PutPixel(19 + x, 24 + y, 255, 255, 71);
        gfx.PutPixel(20 + x, 24 + y, 240, 241, 86);
        gfx.PutPixel(21 + x, 24 + y, 228, 227, 0);
        gfx.PutPixel(22 + x, 24 + y, 251, 251, 68);
        gfx.PutPixel(23 + x, 24 + y, 251, 251, 68);
        gfx.PutPixel(10 + x, 25 + y, 179, 179, 69);
        gfx.PutPixel(11 + x, 25 + y, 218, 217, 12);
        gfx.PutPixel(12 + x, 25 + y, 229, 223, 87);
        gfx.PutPixel(13 + x, 25 + y, 238, 224, 90);
        gfx.PutPixel(14 + x, 25 + y, 246, 227, 76);
        gfx.PutPixel(15 + x, 25 + y, 248, 227, 86);
        gfx.PutPixel(16 + x, 25 + y, 248, 229, 81);
        gfx.PutPixel(17 + x, 25 + y, 254, 250, 14);
        gfx.PutPixel(18 + x, 25 + y, 255, 255, 0);
        gfx.PutPixel(19 + x, 25 + y, 255, 255, 12);
        gfx.PutPixel(20 + x, 25 + y, 243, 243, 15);
        gfx.PutPixel(21 + x, 25 + y, 222, 222, 0);
        gfx.PutPixel(22 + x, 25 + y, 240, 240, 69);
        gfx.PutPixel(23 + x, 25 + y, 251, 251, 68);
        gfx.PutPixel(10 + x, 26 + y, 218, 217, 12);
        gfx.PutPixel(11 + x, 26 + y, 174, 175, 10);
        gfx.PutPixel(12 + x, 26 + y, 214, 214, 30);
        gfx.PutPixel(13 + x, 26 + y, 247, 240, 41);
        gfx.PutPixel(14 + x, 26 + y, 254, 244, 40);
        gfx.PutPixel(15 + x, 26 + y, 254, 244, 40);
        gfx.PutPixel(16 + x, 26 + y, 251, 243, 31);
        gfx.PutPixel(17 + x, 26 + y, 242, 240, 5);
        gfx.PutPixel(18 + x, 26 + y, 251, 252, 0);
        gfx.PutPixel(19 + x, 26 + y, 255, 255, 0);
        gfx.PutPixel(20 + x, 26 + y, 252, 252, 31);
        gfx.PutPixel(21 + x, 26 + y, 232, 232, 66);
        gfx.PutPixel(22 + x, 26 + y, 193, 193, 30);
        gfx.PutPixel(23 + x, 26 + y, 196, 196, 136);
        gfx.PutPixel(10 + x, 27 + y, 166, 166, 18);
        gfx.PutPixel(11 + x, 27 + y, 207, 207, 144);
        gfx.PutPixel(12 + x, 27 + y, 194, 194, 23);
        gfx.PutPixel(13 + x, 27 + y, 216, 217, 0);
        gfx.PutPixel(14 + x, 27 + y, 235, 236, 0);
        gfx.PutPixel(15 + x, 27 + y, 229, 230, 0);
        gfx.PutPixel(16 + x, 27 + y, 212, 213, 0);
        gfx.PutPixel(17 + x, 27 + y, 187, 187, 0);
        gfx.PutPixel(18 + x, 27 + y, 206, 206, 0);
        gfx.PutPixel(19 + x, 27 + y, 230, 230, 0);
        gfx.PutPixel(20 + x, 27 + y, 246, 246, 25);
        gfx.PutPixel(21 + x, 27 + y, 226, 226, 66);
        gfx.PutPixel(22 + x, 27 + y, 161, 161, 21);
        gfx.PutPixel(23 + x, 27 + y, 162, 162, 93);
        gfx.PutPixel(12 + x, 28 + y, 181, 181, 27);
        gfx.PutPixel(13 + x, 28 + y, 181, 181, 27);
        gfx.PutPixel(14 + x, 28 + y, 172, 172, 0);
        gfx.PutPixel(15 + x, 28 + y, 161, 161, 0);
        gfx.PutPixel(16 + x, 28 + y, 161, 161, 17);
        gfx.PutPixel(17 + x, 28 + y, 194, 194, 100);
        gfx.PutPixel(18 + x, 28 + y, 154, 154, 22);
        gfx.PutPixel(19 + x, 28 + y, 209, 209, 69);
        gfx.PutPixel(20 + x, 28 + y, 248, 248, 87);
        gfx.PutPixel(21 + x, 28 + y, 208, 208, 10);
        gfx.PutPixel(22 + x, 28 + y, 218, 217, 12);
        gfx.PutPixel(13 + x, 29 + y, 218, 217, 12);
        gfx.PutPixel(14 + x, 29 + y, 135, 135, 58);
        gfx.PutPixel(15 + x, 29 + y, 126, 126, 60);
        gfx.PutPixel(16 + x, 29 + y, 180, 180, 102);
        gfx.PutPixel(17 + x, 29 + y, 218, 217, 12);
        gfx.PutPixel(18 + x, 29 + y, 161, 161, 104);
        gfx.PutPixel(19 + x, 29 + y, 251, 251, 68);
        gfx.PutPixel(20 + x, 29 + y, 221, 221, 190);
        gfx.PutPixel(21 + x, 29 + y, 218, 218, 94);

    }

    //animation_status++;
    //if (animation_status == 40) { animation_status = 0; }
    // animation unused for now - need to think of something better
}

void Player::setSpeed(int newSpeed)
{
    speed = newSpeed;
}

void Player::keep_boundaries(int boundary, Graphics& gfx) {
    if (y < boundary) { y = boundary; }

    if (y > gfx.ScreenHeight - boundary - height) {
        y = gfx.ScreenHeight - boundary - height;
    }

    if (x < boundary) { x = boundary; }

    if (x > gfx.ScreenWidth - boundary - width) {
        x = gfx.ScreenWidth - boundary - width;
    }
}

void Player::check_collision_bricks(int brickX, int brickY)
{
    player_right_edge = x + width;
    player_bottom_edge = y + height;

    int brick_right_edge = brickX + BRICK_WIDTH;
    int brick_bottom_edge = brickY + BRICK_HEIGHT;

    if (y < brick_bottom_edge && player_right_edge > brickX && player_bottom_edge > brickY && x < brick_right_edge) {
        switch (direction) {
        case UP:
            y += speed;
            break;
        case DOWN:
            y -= speed;
            break;
        case LEFT:
            x += speed;
            break;
        case RIGHT:
            x -= speed;
            break;
        case UPLEFT:
            x += speed;
            y += speed;
            break;
        case UPRIGHT:
            x -= speed;
            y += speed;
            break;
        case DOWNLEFT:
            y -= speed;
            x += speed;
            break;
        case DOWNRIGHT:
            y -= speed;
            x -= speed;
            break;
        default:
            break;
        }
    }
}

bool Player::collides_with_moving_fires(int movingFireX, int movingFireY)
{
    player_right_edge = x + width;
    player_bottom_edge = y + height;

    int moving_fire_right_edge = movingFireX + MOVING_FIRE_WIDTH;
    int moving_fire_bottom_edge = movingFireY + MOVING_FIRE_HEIGHT;

    if (y < moving_fire_bottom_edge && player_right_edge > movingFireX && player_bottom_edge > movingFireY && x < moving_fire_right_edge) {
        return true;
    }
    else {
        return false;
    }
}

bool Player::collides(int objectX, int objectY, int objectWidth, int objectHeight)
{
    player_right_edge = x + width;
    player_bottom_edge = y + height;

    int object_right_edge = objectX + objectWidth;
    int object_bottom_edge = objectY + objectHeight;

    if (y < object_bottom_edge && player_right_edge > objectX && player_bottom_edge > objectY && x < object_right_edge) {
        return true;
    }
    else {
        return false;
    }
}

bool Player::collides_with_level_exit(int levelExitX, int levelExitY)
{
    player_right_edge = x + width;
    player_bottom_edge = y + height;

    int level_exit_right_edge = levelExitX + LEVEL_EXIT_WIDTH;
    int level_exit_bottom_edge = levelExitY + LEVEL_EXIT_HEIGHT;

    if (y < level_exit_bottom_edge && player_right_edge > levelExitX && player_bottom_edge > levelExitY && x < level_exit_right_edge) {
        return true;
    }
    else {
        return false;
    }
}